/*
 *  TOPPERS/A-COM
 *      Automotive COM
 *
 *  Copyright (C) 2013-2015 by Center for Embedded Computing Systems
 *                             Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2013-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2013-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2013-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *  Copyright (C) 2013-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2013-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2013-2015 by Witz Corporation
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: Com.c 1475 2015-06-25 04:15:31Z fsi-kaitori $
 */

/* [COM584] Com.c */

/*
 *  ȯ
 *  - [COM010] APIOSEK/VDX COMƱΤΤȤ
 *  - [COM011] OSEKͤAUTOSARͤ㤬ΤAUTOSARͤ˽򤹤
 *  - [COM012] AUTOSARͤǤΤߵꤵƤͤ
 *  - [COM013] ͥåȥåΰOSEKͤϼɬܤǤʤᡤʤ
 */

/* [COM220] */
#include "Com.h"
/*
 *  [NCOM032] SchM_Com.hRTEͥ졼ˤ
 *  [COM320][COM321] ܼǤϤ٤ƤΥƥॵӥꥨȥȤȤ
 */
#include "SchM_Com.h"

#if COM_DEV_ERROR_DETECT == STD_ON
/* [COM670] */
#include "Det.h"
#endif /* COM_DEV_ERROR_DETECT == STD_ON */

/* [COM669] */
/* PduR_Com.hPduRͥ졼ˤ */
#include "PduR_Com.h"

/*
 *  ؿΥץȥ
 */
/*  */
static void init_ipdu(const IPDU_INIB *p_ipdu_inib);
LOCAL_INLINE void clear_occurrence(const IPDU_INIB *p_ipdu_inib);
static boolean filtering(const SIGNAL_INIB *p_signal_inib, const void *p_data);
LOCAL_INLINE void set_filter_buffer(const SIGNAL_INIB	*p_signal_inib, const void *p_data);
LOCAL_INLINE uint32 copy_signal_to_uint32(const SIGNAL_INIB *p_signal_inib, const void *p_data);
LOCAL_INLINE sint32 cast_signal_to_sint32(const SIGNAL_INIB *p_signal_inib, const void *p_data);
/*  */
LOCAL_INLINE void send_ipdu(const IPDU_INIB *p_ipdu_inib);
LOCAL_INLINE Std_ReturnType send_ipdu_respect_mdt(const IPDU_INIB *p_ipdu_inib);
LOCAL_INLINE void set_mdt(const IPDU_INIB *p_ipdu_inib);
LOCAL_INLINE void start_tx_dm(const IPDU_INIB *p_ipdu_inib);
LOCAL_INLINE void packing(const SIGNAL_INIB *p_signal_inib, const void *p_data);
LOCAL_INLINE void pack_little_endian(uint8 p_buffer[], PduLengthType byte_index, uint8 pos_lsb, uint8 bitsize, uint32 signal_data);
LOCAL_INLINE void pack_big_endian(uint8 p_buffer[], PduLengthType byte_index, uint8 pos_lsb, uint8 bitsize, uint32 signal_data);
LOCAL_INLINE void set_updatebit(const SIGNAL_INIB *p_signal_inib);
LOCAL_INLINE void clear_updatebit(const IPDU_INIB *p_ipdu_inib);
LOCAL_INLINE boolean check_tx_signal(const SIGNAL_INIB *p_signal_inib, const void *p_data);
LOCAL_INLINE void set_tx_signal(const SIGNAL_INIB *p_signal_inib, const void *p_data);
LOCAL_INLINE boolean check_tms(const IPDU_INIB *p_ipdu_inib);
LOCAL_INLINE void switch_tx_mode(const IPDU_INIB *p_ipdu_inib, boolean tms);
LOCAL_INLINE void set_tx_mode(const IPDU_INIB *p_ipdu_inib, boolean tms);
/*  */
LOCAL_INLINE void receive_ipdu(const IPDU_INIB *p_ipdu_inib);
LOCAL_INLINE void unpacking(const SIGNAL_INIB *p_signal_inib, void *p_data);
LOCAL_INLINE boolean check_invalid(const SIGNAL_INIB *p_signal_inib, void *p_data);
LOCAL_INLINE boolean check_updatebit(const SIGNAL_INIB *p_signal_inib);
LOCAL_INLINE void set_rx_signal(const SIGNAL_INIB *p_signal_inib, const void *p_data);
LOCAL_INLINE void get_rx_signal(const SIGNAL_INIB *p_signal_inib, void *p_data);
LOCAL_INLINE void start_rx_dm(const IPDU_INIB *p_ipdu_inib);
LOCAL_INLINE void stop_rx_dm(const IPDU_INIB *p_ipdu_inib);
LOCAL_INLINE void check_rx_dm(const SIGNAL_INIB *p_signal_inib);
LOCAL_INLINE void reset_rx_dm(const SIGNAL_INIB *p_signal_inib);


/*
 *  ߼¹Comե졼
 */
static const Com_ConfigType	*p_cur_com_config;
static const SIGNAL_INIB	*p_cur_signal_inib;
static const IPDU_INIB		* const *pp_cur_all_ipdu_inib;
static const IPDU_INIB		*p_cur_rx_ipdu_inib;
static const IPDU_INIB		*p_cur_tx_ipdu_inib;

/*
 *  Comν
 */
static Com_StatusType		com_state = COM_UNINIT;


/*
 *  [COM432] Com_Init
 */
void
Com_Init(const Com_ConfigType *config)
{
	const IPDU_INIB	*p_ipdu_inib;
	PduIdType		i;

	SchM_Enter_Com_Reentrant_0();

	/* [COM373] Com_Initˤݥȥӥɥѥ᡼̤(̤)Τ߹Ǥ */
	COM_CHECK_UNINITIALIZED(COMServiceId_Init);

	/* [COM433] ʥݥ󥿤ؤбϡNULL_PTRФƤΤ߹Ԥ */
	if (config == NULL_PTR) {
		/* [NCOM040] NULL_PTRξ硤ComConfigurationId0Υե졼Ȥ */
		config = &com_config[0];
	}

	/* ߼¹Υե졼ݻ */
	p_cur_com_config = config;
	p_cur_signal_inib = p_cur_com_config->p_signal_inib_table;
	pp_cur_all_ipdu_inib = p_cur_com_config->pp_ipdu_inib_table;
	p_cur_rx_ipdu_inib = p_cur_com_config->p_rx_ipdu_inib_list;
	p_cur_tx_ipdu_inib = p_cur_com_config->p_tx_ipdu_inib_list;

	/* [COM128] IPDUν */
	for (i = 0U; i < GET_IPDU_NUM(); i++) {
		p_ipdu_inib = GET_IPDU_INIB(i);

		/* [COM217][COM098][COM483][COM117] IPDUν */
		init_ipdu(p_ipdu_inib);

		/* [COM328][COM444] IPDU */
		IPDU_CLEAR_STARTED(p_ipdu_inib->p_state);
	}

	/* COM֤ذܹ */
	com_state = COM_INIT;

  error_exit:
	SchM_Exit_Com_Reentrant_0();
	return;
}

/*
 *  [COM130] Com_DeInit
 */
void
Com_DeInit(void)
{
	PduIdType		i;
	const IPDU_INIB	*p_ipdu_inib;

	SchM_Enter_Com_Reentrant_0();

	COM_CHECK_INITIALIZED(COMServiceId_DeInit);

	/* [COM129] IPDU롼פ */
	for (i = 0U; i < GET_IPDU_NUM(); i++) {
		p_ipdu_inib = GET_IPDU_INIB(i);
		IPDU_CLEAR_ALL(p_ipdu_inib->p_state);
	}

	/* COM̤֤ذܹ */
	com_state = COM_UNINIT;

  error_exit:
	SchM_Exit_Com_Reentrant_0();
	return;
}

/*
 *  [COM751] Com_IpduGroupControl
 */
void
Com_IpduGroupControl(Com_IpduGroupVector ipduGroupVector, boolean initialize)
{
	const Com_ConfigType	*p_saved_config;
	const IPDU_INIB			*p_ipdu_inib;
	const SIGNAL_INIB		*p_signal_inib;
	TX_IPDU_CB				*p_tx_ipdu_cb;
	Com_CbkTxErr			cbk_txerr;
	boolean					start_flg;
	uint8					target, belong;
	PduIdType				i;
	Com_IpduGroupIdType		j;
	Com_SignalIdType		k;

	SchM_Enter_Com_Reentrant_0();

	COM_CHECK_INITIALIZED(COMServiceId_IpduGroupControl);

	/*
	 *  [COM771]
	 *  IPDUߢʤȤ1Ĥν°IPDU롼פ򳫻ϡ
	 *  IPDUϢ٤Ƥν°IPDU롼פ       
	 *  IPDUߢ٤Ƥν°IPDU롼פ       ⤷ʤ
	 *  IPDUϢʤȤ1Ĥν°IPDU롼פ򳫻ϡ⤷ʤ
	 */
	for (i = 0U; i < GET_IPDU_NUM(); i++) {
		p_ipdu_inib = GET_IPDU_INIB(i);

		start_flg = FALSE;
		for (j = 0U; j < GET_VECTOR_NUM(); j++) {
			/* ϻؼ줿IPDU롼ץ٥ */
			target = ipduGroupVector[j];
			/* оIPDUν°IPDU롼ץ٥ */
			belong = (*(p_ipdu_inib->p_ipdu_group_vector))[j];

			/* 1ĤǤ°IPDU롼פϻؼƤ뤫 */
			if ((target & belong) != 0U) {
				start_flg = TRUE;
				/* 1ĤǤⳫϻؼƤФ褤 */
				break;
			}
		}

		/*
		 *  ߤIPDUξ֤˹碌ƽԤ
		 *  [COM613] IPDU롼׼Τξ֤פΤʤ
		 */
		/* [COM614] ߤƤIPDU򳫻Ϥ */
		if ((start_flg != FALSE) && (!IPDU_IS_STARTED(p_ipdu_inib->p_state))) {
			/*
			 *  [COM222][COMa001] initializeFALSEǤꡤIPDUϤ줿硤
			 *  ΤΤMF󥿤Ͻʤ
			 *  [COM740] Com_Init˽Com_IpduGroupControlƤӽФݤˡ
			 *  initializeFALSEꤷ硤TRUEꤷƱ̤ˤʤ
			 */
			if (initialize != FALSE) {
				/* [COM222] IPDUν */
				init_ipdu(p_ipdu_inib);
			}
			else {
				/* [COM787] OCCURRENCEꥢ */
				clear_occurrence(p_ipdu_inib);
			}

			if (p_ipdu_inib->ComIPduDirection == COM_SEND) {
				p_tx_ipdu_cb = (TX_IPDU_CB *) p_ipdu_inib->p_ipdu_cb;
				COM_CHECK_NULL_POINTER(p_tx_ipdu_cb != NULL_PTR, COMServiceId_IpduGroupControl);

				/* 󥿤ν */
				p_tx_ipdu_cb->mdt_mf_cnt = 0U;
				p_tx_ipdu_cb->queuing_cnt = 0U;
				p_tx_ipdu_cb->dm_mf_cnt = 0U;

				/* [COM787][COM217] åץǡȥӥåȥꥢ */
				clear_updatebit(p_ipdu_inib);

				/* [COM229][COM223][COM032][COM238] TMSꤷ⡼ɤꤹ */
				switch_tx_mode(p_ipdu_inib, check_tms(p_ipdu_inib));
			}
			else {
				/* [COM787][COM733] DM */
				start_rx_dm(p_ipdu_inib);
			}

			/* [COM612][COM114] IPDUγ */
			IPDU_SET_STARTED(p_ipdu_inib->p_state);
		}
		/* ϤƤIPDUߤ */
		else if ((start_flg == FALSE) && (IPDU_IS_STARTED(p_ipdu_inib->p_state))) {
			/* IPDU߾֤ˤ */
			IPDU_CLEAR_STARTED(p_ipdu_inib->p_state);
			if (p_ipdu_inib->ComIPduDirection == COM_SEND) {
				p_tx_ipdu_cb = (TX_IPDU_CB *) p_ipdu_inib->p_ipdu_cb;
				COM_CHECK_NULL_POINTER(p_tx_ipdu_cb != NULL_PTR, COMServiceId_IpduGroupControl);

				/* [COM479] ߤ줿IPDUФλΤϤƤʤ硤顼ΤԤ */
				if (p_tx_ipdu_cb->queuing_cnt != 0U) {
					for (k = 0U; k < p_ipdu_inib->tnum_signal; k++) {
						p_signal_inib = GET_SIGNAL_INIB((p_ipdu_inib->p_signalid_list)[k]);
						COM_CHECK_NULL_POINTER(p_signal_inib != NULL_PTR, COMServiceId_IpduGroupControl);

						if (p_signal_inib->ComErrorNotification != NULL_PTR) {
							/* ¾ꥢǥХåΥݥ󥿤Ф */
							cbk_txerr = p_signal_inib->ComErrorNotification;
							/* ƽåѤ˸ߤΥե졼ݻ */
							p_saved_config = p_cur_com_config;

							/* 顼 */
							SchM_Exit_Com_Reentrant_0();
							cbk_txerr();
							SchM_Enter_Com_Reentrant_0();

							/* ¾ꥢǥե졼ѲƤʤå */
							COM_CHECK_PARAM(p_saved_config == p_cur_com_config, COMServiceId_IpduGroupControl);
						}
					}
					p_tx_ipdu_cb->queuing_cnt  = 0U;
				}
				/* [COM115] DM򥭥󥻥뤷ʹߤλΤ̵뤹 */
				IPDU_CLEAR_DM(p_ipdu_inib->p_state);
			}
			else {
				/* [COM685] DM */
				stop_rx_dm(p_ipdu_inib);
			}
			/* [COM684] ̵ˤ */
			IPDU_CLEAR_ALL(p_ipdu_inib->p_state);
		}
		else {
			/* [COM615] ֤Ѥʤϲ⤷ʤ */
		}
	}

  error_exit:
	SchM_Exit_Com_Reentrant_0();
	return;
}

/*
 *  [COM752] Com_ReceptionDMControl
 */
void
Com_ReceptionDMControl(Com_IpduGroupVector ipduGroupVector)
{
	PduIdType			i;
	Com_IpduGroupIdType	j;
	uint8				target, belong;
	boolean				start_flg;
	const IPDU_INIB		*p_ipdu_inib;

	SchM_Enter_Com_Reentrant_0();

	COM_CHECK_INITIALIZED(COMServiceId_ReceptionDMControl);

	/* [COM534] IPDUФƽԤ */
	for (i = 0U; i < GET_RX_IPDU_NUM(); i++) {
		p_ipdu_inib = GET_RX_IPDU_INIB(i);

		start_flg = FALSE;
		for (j = 0U; j < GET_VECTOR_NUM(); j++) {
			/* DMϻؼ줿IPDU롼ץ٥ */
			target = ipduGroupVector[j];
			/* оIPDUν°IPDU롼ץ٥ */
			belong = (*(p_ipdu_inib->p_ipdu_group_vector))[j];

			/* [COM772] 1ĤǤ°IPDU롼פDMϻؼƤ뤫 */
			if ((target & belong) != 0U) {
				start_flg = TRUE;
				/* 1ĤǤⳫϻؼƤФ褤 */
				break;
			}
		}

		/* [COM616][COM617] DMꤵ줿֤ѹϤޤߤ */
		if ((!IPDU_IS_DM(p_ipdu_inib->p_state)) && (start_flg != FALSE)) {
			/* DM */
			start_rx_dm(p_ipdu_inib);
		}
		else if (IPDU_IS_DM(p_ipdu_inib->p_state) && (start_flg == FALSE)) {
			/* DM */
			stop_rx_dm(p_ipdu_inib);
		}
		else {
			/* [COM618][COM225][COM486] ֤Ѥʤϲ⤷ʤ */
		}
	}

  error_exit:
	SchM_Exit_Com_Reentrant_0();
	return;
}

/*
 *  [COM194] Com_GetStatus
 */
Com_StatusType
Com_GetStatus(void)
{
	return(com_state);
}

/*
 *  [COM375] Com_GetConfigurationId
 */
uint32
Com_GetConfigurationId(void)
{
	uint32 id;

	if (com_state != COM_INIT) {
		/* [NCOM001] */
		id = COM_INVALID_UINT32;
	}
	else {
		/* [COM619] */
		id = p_cur_com_config->ComConfigurationId;
	}

	return(id);
}

/* [COM425] Com_GetVersionInfo̵ͭϥե졼ڤؤ */
#if (COM_VERSION_INFO_API == STD_ON)
/*
 *  [COM426] Com_GetVersionInfo
 *  [COM434] ޥǼƤ褤NULLݥ󥿥åΤؿȤ
 */
void
Com_GetVersionInfo(Std_VersionInfoType *versioninfo)
{
	/* [NCOM039] */
	COM_CHECK_NULL_POINTER(versioninfo != NULL_PTR, COMServiceId_GetVersionInfo);

	/* [COM424] */
	versioninfo->vendorID = COM_VENDOR_ID;
	versioninfo->moduleID = COM_MODULE_ID;
	versioninfo->sw_major_version = COM_SW_MAJOR_VERSION;
	versioninfo->sw_minor_version = COM_SW_MINOR_VERSION;
	versioninfo->sw_patch_version = COM_SW_PATCH_VERSION;

  error_exit:
	return;
}
#endif /* COM_VERSION_INFO_API */

/*
 *  [COM749] Com_ClearIpduGroupVector
 */
void
Com_ClearIpduGroupVector(Com_IpduGroupVector ipduGroupVector)
{
	Com_IpduGroupIdType	i;

	for (i = 0U; i < IPDU_GROUP_VECTOR_NUM; i++) {
		ipduGroupVector[i] = 0U;
	}

	return;
}

/*
 *  [COM750] Com_SetIpduGroup
 */
void
Com_SetIpduGroup(Com_IpduGroupVector ipduGroupVector, Com_IpduGroupIdType ipduGroupId, boolean bitval)
{
	SchM_Enter_Com_Reentrant_0();

	COM_CHECK_INITIALIZED(COMServiceId_SetIpduGroup);
	COM_CHECK_PARAM(ipduGroupId < GET_IPDU_G_NUM(), COMServiceId_SetIpduGroup);

	/* [COM623] ꤵ줿IPDUбӥåȤ򥻥å */
	if (bitval) {
		ipduGroupVector[ipduGroupId / 8U] |= (uint8) (1U << (ipduGroupId % 8U));
	}
	else {
		ipduGroupVector[ipduGroupId / 8U] &= (uint8) (~(uint8) (1U << (ipduGroupId % 8U)));
	}

  error_exit:
	SchM_Exit_Com_Reentrant_0();

	return;
}

/*
 *  [COM197] Com_SendSignal
 */
uint8
Com_SendSignal(Com_SignalIdType SignalId, const void *SignalDataPtr)
{
	const SIGNAL_INIB	*p_signal_inib;
	const IPDU_INIB		*p_ipdu_inib;
	TX_SIGNAL_CB		*p_tx_signal_cb;
	TX_IPDU_CB			*p_tx_ipdu_cb;
	boolean				changed;
	boolean				tms;
	uint8				ercd;

	SchM_Enter_Com_Reentrant_0();

	COM_CHECK_INITIALIZED_ERCD(COMServiceId_SendSignal);
	COM_CHECK_PARAM_ERCD(SignalId < GET_SIGNAL_NUM(), COMServiceId_SendSignal);
	COM_CHECK_NULL_POINTER_ERCD(SignalDataPtr != NULL_PTR, COMServiceId_SendSignal);

	/* [COM624] */
	p_signal_inib = GET_SIGNAL_INIB(SignalId);
	p_ipdu_inib = p_signal_inib->p_ipdu_inib;
	p_tx_ipdu_cb = (TX_IPDU_CB *) p_ipdu_inib->p_ipdu_cb;
	p_tx_signal_cb = (TX_SIGNAL_CB *) p_signal_inib->p_signal_cb;

	COM_CHECK_PARAM_ERCD(p_ipdu_inib->ComIPduDirection == COM_SEND, COMServiceId_SendSignal);

	/* ʥǡ */
	changed = check_tx_signal(p_signal_inib, SignalDataPtr);

	if (changed != FALSE) {
		/* ʥХåե˥ʥǡǼ */
		set_tx_signal(p_signal_inib, SignalDataPtr);

		/* [COM334][COM221] IPDUǤХåեι(ѥå)Ԥ */
		packing(p_signal_inib, SignalDataPtr);
	}

	/* [COMa003] åץǡȥӥå */
	set_updatebit(p_signal_inib);

	/* [COM245] COM_NEVERʳΥե륿ľΤߡTMSȽԤ */
	if ((p_signal_inib->ComFilterAlgorithm != COM_INVALID_UINT8) && (p_signal_inib->ComFilterAlgorithm != COM_NEVER)) {
		COM_CHECK_NULL_POINTER_ERCD(p_tx_signal_cb != NULL_PTR, COMServiceId_SendSignal);

		/* [COM602] TMCȽ */
		p_tx_signal_cb->tmc = filtering(p_signal_inib, SignalDataPtr);

		/* [COM605] TMSȽ */
		tms = check_tms(p_ipdu_inib);

		/* ⡼ڤؤ */
		switch_tx_mode(p_ipdu_inib, tms);
	}

	/* IPDUȽ */
	if (IPDU_IS_STARTED(p_ipdu_inib->p_state)) {

		COM_CHECK_PARAM_ERCD(((p_tx_ipdu_cb->p_cur_tx_mode_inib->ComTxModeMode >= COM_DIRECT) &&
							  (p_tx_ipdu_cb->p_cur_tx_mode_inib->ComTxModeMode <= COM_MIXED)) ||
							 (p_tx_ipdu_cb->p_cur_tx_mode_inib->ComTxModeMode == COM_NONE), COMServiceId_SendSignal);

		/* [COM279] COM_DIRECT,COM_MIXED */
		if ((p_tx_ipdu_cb->p_cur_tx_mode_inib->ComTxModeMode == COM_DIRECT) ||
			(p_tx_ipdu_cb->p_cur_tx_mode_inib->ComTxModeMode == COM_MIXED)) {

			/* [COM330][COM734] ֤ */
			if ((p_signal_inib->ComTransferProperty == COM_TRIGGERED) ||
				((p_signal_inib->ComTransferProperty == COM_TRIGGERED_ON_CHANGE) && (changed != FALSE))) {
				/*
				 * μǤϡComTxModeNumberOfRepetitions0ξϡ֤Ԥʤ
				 * 1ξˤƤ⡤֤ԤʤȤ0ξƱȡˤƤ롥
				 * MFTxǤˤơrepeat_cnt0Ǥ뤳Ȥǡʹߤη̵֤Ȥ
				 * ȽꤷƤ뤿ᡤComTxModeNumberOfRepetitions1ξϡrepeat_cnt0ꤷƤ
				 */
				if (p_tx_ipdu_cb->p_cur_tx_mode_inib->ComTxModeNumberOfRepetitions != 1U) {
					p_tx_ipdu_cb->repeat_cnt = p_tx_ipdu_cb->p_cur_tx_mode_inib->ComTxModeNumberOfRepetitions;
				}
				else {
					p_tx_ipdu_cb->repeat_cnt = 0U;
				}

				p_tx_ipdu_cb->interval_mf_cnt = 0U;

				/* [NCOM006] ľӥåȤ */
				IPDU_SET_DIRECT_SEND(p_ipdu_inib->p_state);
				IPDU_SET_FIRST_DIRECT_SEND(p_ipdu_inib->p_state);

				/*
				 * [COM739] ⡼ɤDIRECTǤꡤġ֤Ԥ硤
				 * ׵᤬äݤDMꥻåȤ
				 */
				if ((p_tx_ipdu_cb->p_cur_tx_mode_inib->ComTxModeMode >= COM_DIRECT) &&
					(p_tx_ipdu_cb->p_cur_tx_mode_inib->ComTxModeNumberOfRepetitions > 0)) {
					IPDU_CLEAR_DM(p_ipdu_inib->p_state);
				}
			}
			/* [COM767][COM768] */
			else if ((p_signal_inib->ComTransferProperty == COM_TRIGGERED_WITHOUT_REPETITION) ||
					 ((p_signal_inib->ComTransferProperty == COM_TRIGGERED_ON_CHANGE_WITHOUT_REPETITION) && (changed != FALSE))) {

				/* [COM467] 1Τ */
				p_tx_ipdu_cb->repeat_cnt = 0U;

				p_tx_ipdu_cb->interval_mf_cnt = 0U;

				/* [NCOM006] ľӥåȤ */
				IPDU_SET_DIRECT_SEND(p_ipdu_inib->p_state);
				IPDU_SET_FIRST_DIRECT_SEND(p_ipdu_inib->p_state);
			}
			else {
				/* COM_PENDING: ⤷ʤ */
			}
		}
		ercd = E_OK;
	}
	else {
		ercd = COM_SERVICE_NOT_AVAILABLE;
	}

  error_exit:
	SchM_Exit_Com_Reentrant_0();

	return(ercd);
}

/*
 *  [COM198] Com_ReceiveSignal
 */
uint8
Com_ReceiveSignal(Com_SignalIdType SignalId, void *SignalDataPtr)
{
	const SIGNAL_INIB	*p_signal_inib;
	const IPDU_INIB		*p_ipdu_inib;
	uint8				ercd;

	SchM_Enter_Com_Reentrant_0();

	COM_CHECK_INITIALIZED_ERCD(COMServiceId_ReceiveSignal);
	COM_CHECK_PARAM_ERCD(SignalId < GET_SIGNAL_NUM(), COMServiceId_ReceiveSignal);
	COM_CHECK_NULL_POINTER_ERCD(SignalDataPtr != NULL_PTR, COMServiceId_ReceiveSignal);

	p_signal_inib = GET_SIGNAL_INIB(SignalId);
	p_ipdu_inib = p_signal_inib->p_ipdu_inib;

	COM_CHECK_PARAM_ERCD(p_ipdu_inib->ComIPduDirection == COM_RECEIVE, COMServiceId_ReceiveSignal);

	/* [COM631] SignalDataPtrSignalIdΥʥǡ򥳥ԡ */
	get_rx_signal(p_signal_inib, SignalDataPtr);

	/* IPDUϾȽ */
	if (IPDU_IS_STARTED(p_ipdu_inib->p_state)) {
		ercd = E_OK;
	}
	else {
		ercd = COM_SERVICE_NOT_AVAILABLE;
	}

  error_exit:
	SchM_Exit_Com_Reentrant_0();

	return(ercd);
}

/*
 *  [COM203] Com_InvalidateSignal
 */
uint8
Com_InvalidateSignal(Com_SignalIdType SignalId)
{
	const SIGNAL_INIB	*p_signal_inib;
	const void			*p_invaild;
	uint8				ercd;

	SchM_Enter_Com_Reentrant_2();

	COM_CHECK_INITIALIZED_ERCD(COMServiceId_SendSignal);
	COM_CHECK_PARAM_ERCD(SignalId < GET_SIGNAL_NUM(), COMServiceId_InvalidateSignal);

	p_signal_inib = GET_SIGNAL_INIB(SignalId);
	/* ¾ꥢ̵ͤФ */
	p_invaild = p_signal_inib->ComSignalDataInvalidValue;

	if (p_invaild != NULL_PTR) {
		/* [COM099][COM642] */
		ercd = Com_SendSignal(SignalId, p_invaild);
	}
	else {
		/* [COM643] */
		ercd = COM_SERVICE_NOT_AVAILABLE;
	}

  error_exit:
	SchM_Exit_Com_Reentrant_2();

	return(ercd);
}

/*
 *  [COM348] Com_TriggerIPDUSend
 */
void
Com_TriggerIPDUSend(PduIdType PduId)
{
	const IPDU_INIB	*p_ipdu_inib;

	SchM_Enter_Com_Reentrant_0();

	COM_CHECK_INITIALIZED(COMServiceId_TriggerIPDUSend);
	COM_CHECK_PARAM(PduId < GET_IPDU_NUM(), COMServiceId_TriggerIPDUSend);

	p_ipdu_inib = GET_IPDU_INIB(PduId);
	COM_CHECK_PARAM(p_ipdu_inib->ComIPduDirection == COM_SEND, COMServiceId_TriggerIPDUSend);

	/* IPDU߻ϲ⤷ʤ */
	if (IPDU_IS_STARTED(p_ipdu_inib->p_state)) {
		/* [COM492]MF˥륢ȤƤӽФ */
		IPDU_SET_TRIGGERED(p_ipdu_inib->p_state);
	}

  error_exit:
	SchM_Exit_Com_Reentrant_0();
	return;
}

/*
 *  [COM784] Com_SwitchIpduTxMode
 */
void
Com_SwitchIpduTxMode(PduIdType PduId, boolean Mode)
{
	const IPDU_INIB		*p_ipdu_inib;

	SchM_Enter_Com_Reentrant_0();

	COM_CHECK_INITIALIZED(COMServiceId_SwitchIpduTxMode);
	COM_CHECK_PARAM(PduId < GET_IPDU_NUM(), COMServiceId_SwitchIpduTxMode);

	p_ipdu_inib = GET_IPDU_INIB(PduId);
	COM_CHECK_PARAM(p_ipdu_inib->ComIPduDirection == COM_SEND, COMServiceId_SwitchIpduTxMode);

	/* γϻ˥ե륿ȽꤷƷ̤Ѥ뤿ᡤIPDU߻˼»ܤɬפϤʤ */
	if (IPDU_IS_STARTED(p_ipdu_inib->p_state)) {
		switch_tx_mode(p_ipdu_inib, Mode);
	}

  error_exit:
	SchM_Exit_Com_Reentrant_0();
	return;
}

/*
 *  [COM123] Com_RxIndication
 */
void
Com_RxIndication(PduIdType RxPduId, PduInfoType *PduInfoPtr)
{
	const IPDU_INIB			*p_ipdu_inib;
	const Com_ConfigType	*p_saved_config;
	Com_IpduCallout			callout;
	PduIdType				i;
	boolean					ret;

	/* [COM649] ߤƤӽФǽΤ¾ɬ */
	SchM_Enter_Com_Reentrant_0();

	COM_CHECK_INITIALIZED(COMServiceId_RxIndication);
	COM_CHECK_PARAM(RxPduId < GET_IPDU_NUM(), COMServiceId_RxIndication);
	COM_CHECK_NULL_POINTER(PduInfoPtr != NULL_PTR, COMServiceId_RxIndication);

	p_ipdu_inib = GET_IPDU_INIB(RxPduId);

	COM_CHECK_PARAM((p_ipdu_inib->ComIPduDirection == COM_RECEIVE), COMServiceId_RxIndication);
	COM_CHECK_PARAM((p_ipdu_inib->ComIPduSignalProcessing == COM_IMMEDIATE) ||
					(p_ipdu_inib->ComIPduSignalProcessing == COM_DEFERRED), COMServiceId_RxIndication);

	/* [COMa005] IPDUΥǡĹͰʾξ硤»ܤ */
	if (PduInfoPtr->SduLength >= p_ipdu_inib->PduLength) {
		/* IPDU߻ϲ⤷ʤ */
		if (IPDU_IS_STARTED(p_ipdu_inib->p_state)) {
			/* [COM700] 륢Ƚ */
			if (p_ipdu_inib->ComIPduCallout != NULL_PTR) {
				/* ¾ꥢǥ륢ȤΥݥ󥿤Ф */
				callout = p_ipdu_inib->ComIPduCallout;
				/* ƽåѤ˸ߤΥե졼ݻ */
				p_saved_config = p_cur_com_config;

				/* [COM381] Com_TriggerIPDUSend, Com_SendSignalϥ륢ȤƽФǽȤ */
				SchM_Exit_Com_Reentrant_0();
				ret = callout(RxPduId, PduInfoPtr->SduDataPtr);
				SchM_Enter_Com_Reentrant_0();

				/* ¾ꥢǥե졼ѲƤʤå */
				COM_CHECK_PARAM(p_saved_config == p_cur_com_config, COMServiceId_RxIndication);

				if (ret == FALSE) {
					/* [COMa004] FALSEξ硤ʹߤν»ܤʤ */
					goto error_exit;
				}
			}

			/* IPDUХåե˼ǡ򥳥ԡ */
			for (i = 0U; i < p_ipdu_inib->PduLength; i++) {
				(p_ipdu_inib->p_ipdu_buffer)[i] = (PduInfoPtr->SduDataPtr)[i];
			}

			if (p_ipdu_inib->ComIPduSignalProcessing == COM_IMMEDIATE) {
				/* [COM300] COM_IMMEDIATEʤФǼ */
				receive_ipdu(p_ipdu_inib);
			}
			/* IPDU֤ */
			IPDU_SET_NOTICED(p_ipdu_inib->p_state);
		}
	}

  error_exit:
	SchM_Exit_Com_Reentrant_0();
	return;
}

/*
 *  [COM124] Com_TxConfirmation
 */
void
Com_TxConfirmation(PduIdType TxPduId)
{
	const IPDU_INIB			*p_ipdu_inib;
	const TX_IPDU_INIB		*p_tx_ipdu_inib;
	const SIGNAL_INIB		*p_signal_inib;
	const Com_ConfigType	*p_saved_config;
	Com_CbkAck				cbk_ack;
	TX_IPDU_CB				*p_tx_ipdu_cb;
	Com_SignalIdType		i;

	/* [COM652] ߤƤӽФǽΤ¾ɬ */
	SchM_Enter_Com_Reentrant_1();

	COM_CHECK_INITIALIZED(COMServiceId_TxConfirmation);
	COM_CHECK_PARAM(TxPduId < GET_IPDU_NUM(), COMServiceId_TxConfirmation);

	p_ipdu_inib = GET_IPDU_INIB(TxPduId);

	COM_CHECK_PARAM(p_ipdu_inib->ComIPduDirection == COM_SEND, COMServiceId_TxConfirmation);

	p_tx_ipdu_cb = (TX_IPDU_CB *) p_ipdu_inib->p_ipdu_cb;
	p_tx_ipdu_inib = p_ipdu_inib->p_tx_ipdu_inib;

	/* PduR_ComTransmitΤ߼դ */
	if (p_tx_ipdu_cb->queuing_cnt != 0U) {
		p_tx_ipdu_cb->queuing_cnt--;

		/* [COM577] */
		if (p_tx_ipdu_inib->ComTxIPduClearUpdateBit == COM_CONFIRMATION) {
				/* åץǡȥӥåȥꥢ */
			clear_updatebit(p_ipdu_inib);
		}

		/* [COM469] MDT󥿤0礭硤MDT󥿤ꤹ */
		if (p_tx_ipdu_inib->ComMinimumDelayTime > 0U) {
			set_mdt(p_ipdu_inib);
		}

		if (p_tx_ipdu_cb->repeat_cnt > 0U) {
			p_tx_ipdu_cb->repeat_cnt--;
		}

		/* IPDU */
		/* [COMa002] IPDU߻RTEΤԤʤ */
		if (IPDU_IS_STARTED(p_ipdu_inib->p_state)) {
			IPDU_CLEAR_FIRST_DIRECT_SEND(p_ipdu_inib->p_state);

			/* λ */
			if (p_tx_ipdu_cb->repeat_cnt == 0U) {
				IPDU_CLEAR_DIRECT_SEND(p_ipdu_inib->p_state);

				/* 
				 * [COM308] IPDU򷫤֤ʬλΤä
				 * DMߤ(ľNʳξλΤ٤)
				 */
				IPDU_CLEAR_DM(p_ipdu_inib->p_state);

				/* Ƚ */
				if (p_ipdu_inib->ComIPduSignalProcessing == COM_IMMEDIATE) {
					for (i = 0U; i < p_ipdu_inib->tnum_signal; i++) {
						p_signal_inib = GET_SIGNAL_INIB((p_ipdu_inib->p_signalid_list)[i]);
						if (p_signal_inib->ComNotification != NULL_PTR) {
							/* ¾ꥢǥХåΥݥ󥿤Ф */
							cbk_ack = p_signal_inib->ComNotification;
							/* ƽåѤ˸ߤΥե졼ݻ */
							p_saved_config = p_cur_com_config;

							/* λ */
							SchM_Exit_Com_Reentrant_1();
							cbk_ack();
							SchM_Enter_Com_Reentrant_1();

							/* ¾ꥢǥե졼ѲƤʤå */
							COM_CHECK_PARAM(p_saved_config == p_cur_com_config, COMServiceId_TxConfirmation);
						}
					}
				}
				else {
					/* Com_MainFunctionTxΤ */
					IPDU_SET_NOTICED(p_ipdu_inib->p_state);
				}
			}
		}
	}

  error_exit:
	SchM_Exit_Com_Reentrant_1();
	return;
}

/*
 *  [COM398] Com_MainFunctionRx
 */
void
Com_MainFunctionRx(void)
{
	PduIdType			i;
	uint16				j;
	const IPDU_INIB		*p_ipdu_inib;
	const SIGNAL_INIB	*p_signal_inib;

	SchM_Enter_Com_Reentrant_0();

	/* [COM664] Ƥʤϲ⤻return */
	if (com_state != COM_INIT) {
		goto error_exit;
	}

	for (i = 0U; i < GET_RX_IPDU_NUM(); i++) {
		p_ipdu_inib = GET_RX_IPDU_INIB(i);

		/* IPDUȽ(Ͼ) */
		if (IPDU_IS_STARTED(p_ipdu_inib->p_state)) {
			if (IPDU_IS_NOTICED(p_ipdu_inib->p_state)) {
				if (p_ipdu_inib->ComIPduSignalProcessing == COM_DEFERRED) {
					/* [COM301] ֤ȤʤäƤCOM_DEFERREDIPDUϤǼ򤹤 */
					receive_ipdu(p_ipdu_inib);
				}

				for (j = 0U; j < p_ipdu_inib->tnum_signal; j++) {
					p_signal_inib = GET_SIGNAL_INIB((p_ipdu_inib->p_signalid_list)[j]);

					if (check_updatebit(p_signal_inib) != FALSE) {
						/*
						 * [COM715][NCOM031][COM738] DM󥿥ꥻåȽ
						 * [NCOM034] DMꥻåȤ硤DMåʤ
						 */
						reset_rx_dm(p_signal_inib);
					}
					else {
						/* åץǡȥӥåȤƤʤʥϼDMå */
						check_rx_dm(p_signal_inib);
					}
				}

				/* IPDUμ֤򥯥ꥢ */
				IPDU_CLEAR_NOTICED(p_ipdu_inib->p_state);
			}
			else {
				/* [COM290][COM292][NCOM035]֤ǤʤIPDUϼDMå */
				for (j = 0U; j < p_ipdu_inib->tnum_signal; j++) {
					p_signal_inib = GET_SIGNAL_INIB((p_ipdu_inib->p_signalid_list)[j]);
					check_rx_dm(p_signal_inib);
				}
			}
		}
	}

  error_exit:
	SchM_Exit_Com_Reentrant_0();
	return;
}

/*
 *  [COM399] Com_MainFunctionTx
 */
void
Com_MainFunctionTx(void)
{
	const IPDU_INIB			*p_ipdu_inib;
	const SIGNAL_INIB		*p_signal_inib;
	const Com_ConfigType	*p_saved_config;
	TX_IPDU_CB				*p_tx_ipdu_cb;
	Com_CbkAck				cbk_ack;
	Com_CbkTOut				cbk_tout;
	PduIdType				i;
	Com_SignalIdType		j;

	SchM_Enter_Com_Reentrant_0();

	/* [COM665] Ƥʤϲ⤻return */
	if (com_state != COM_INIT) {
		goto error_exit;
	}

	for (i = 0U; i < GET_TX_IPDU_NUM(); i++) {
		p_ipdu_inib = GET_TX_IPDU_INIB(i);
		p_tx_ipdu_cb = (TX_IPDU_CB *) p_ipdu_inib->p_ipdu_cb;

		/* [COM777] IPDUȽ IPDUߤƤϡʤ */
		if (IPDU_IS_STARTED(p_ipdu_inib->p_state)) {

			COM_CHECK_PARAM(((p_tx_ipdu_cb->p_cur_tx_mode_inib->ComTxModeMode >= COM_DIRECT) &&
							 (p_tx_ipdu_cb->p_cur_tx_mode_inib->ComTxModeMode <= COM_MIXED)) ||
							(p_tx_ipdu_cb->p_cur_tx_mode_inib->ComTxModeMode == COM_NONE), COMServiceId_MainFunctionTx);

			/* IPDUϻMDT뤿ᡤIPDUϤƤΤMDT򹹿 */
			if (p_tx_ipdu_cb->mdt_mf_cnt > 0U) {
				p_tx_ipdu_cb->mdt_mf_cnt--;
			}

			/* Ƚ */
			if (IPDU_IS_NOTICED(p_ipdu_inib->p_state)) {
				for (j = 0U; j < p_ipdu_inib->tnum_signal; j++) {
					p_signal_inib = GET_SIGNAL_INIB((p_ipdu_inib->p_signalid_list)[j]);
					if (p_signal_inib->ComNotification != NULL_PTR) {
						/* ¾ꥢǥХåΥݥ󥿤Ф */
						cbk_ack = p_signal_inib->ComNotification;
						/* ƽåѤ˸ߤΥե졼ݻ */
						p_saved_config = p_cur_com_config;

						/* λ */
						SchM_Exit_Com_Reentrant_0();
						cbk_ack();
						SchM_Enter_Com_Reentrant_0();

						/* ¾ꥢǥե졼ѲƤʤå */
						COM_CHECK_PARAM(p_saved_config == p_cur_com_config, COMServiceId_MainFunctionTx);
					}
				}
				IPDU_CLEAR_NOTICED(p_ipdu_inib->p_state);
				/* DM */
				IPDU_CLEAR_DM(p_ipdu_inib->p_state);
			}
			/* DM */
			else {
				if (p_tx_ipdu_cb->dm_mf_cnt > 0U) {
					p_tx_ipdu_cb->dm_mf_cnt--;
				}

				/* ॢȯ */
				if ((IPDU_IS_DM(p_ipdu_inib->p_state)) && (p_tx_ipdu_cb->dm_mf_cnt == 0U)) {

/* [COM670] */
#if COM_IPDU_CANCELLATION_SUPPORT == STD_ON
					/* [COM708] */
					if ((p_ipdu_inib->ComIPduCancellationSupport != FALSE) && (p_ipdu_inib->ComIPduType == COM_NORMAL)) {
						(void) PduR_ComCancelTransmit(p_ipdu_inib->PduRSourcePduHandleId);
					}
#endif /* COM_IPDU_CANCELLATION_SUPPORT == STD_ON */
					for (j = 0U; j < p_ipdu_inib->tnum_signal; j++) {
						p_signal_inib = GET_SIGNAL_INIB((p_ipdu_inib->p_signalid_list)[j]);
						if (p_signal_inib->ComTimeoutNotification != NULL_PTR) {
							/* ¾ꥢǥХåΥݥ󥿤Ф */
							cbk_tout = p_signal_inib->ComTimeoutNotification;
							/* ƽåѤ˸ߤΥե졼ݻ */
							p_saved_config = p_cur_com_config;

							/* ॢ */
							SchM_Exit_Com_Reentrant_0();
							/* [COM304] */
							cbk_tout();
							SchM_Enter_Com_Reentrant_0();

							/* ¾ꥢǥե졼ѲƤʤå */
							COM_CHECK_PARAM(p_saved_config == p_cur_com_config, COMServiceId_MainFunctionTx);
						}
					}
					/* DM */
					IPDU_CLEAR_DM(p_ipdu_inib->p_state);
					/* [COM392] ߤ */
					IPDU_CLEAR_DIRECT_SEND(p_ipdu_inib->p_state);
					IPDU_CLEAR_FIRST_DIRECT_SEND(p_ipdu_inib->p_state);
					p_tx_ipdu_cb->repeat_cnt = 0U;
					/* 塼󥰤0ǽ */
					p_tx_ipdu_cb->queuing_cnt = 0U;
					/* [COMa006] MDTꥻå */
					p_tx_ipdu_cb->mdt_mf_cnt = 0U;

#if COM_RETRY_FAILED_TRANSMIT_REQUESTS == STD_ON
					/* [COM775] α줿׵̵ˤ */
					IPDU_CLEAR_RETRY(p_ipdu_inib->p_state);
#endif
				}
			}

			/* IPDU */
			send_ipdu(p_ipdu_inib);
		}
	}

  error_exit:
	SchM_Exit_Com_Reentrant_0();
	return;
}


/*
 *  IPDUν
 */
static void
init_ipdu(const IPDU_INIB *p_ipdu_inib)
{
	const TX_IPDU_INIB	*p_tx_ipdu_inib;
	const SIGNAL_INIB	*p_signal_inib;
	TX_SIGNAL_CB		*p_tx_signal_cb;
	Com_SignalIdType	i;
	PduLengthType		j;

	COM_CHECK_NULL_POINTER(p_ipdu_inib != NULL_PTR, COMServiceId_ipdu_initialize);

	if (p_ipdu_inib->ComIPduDirection == COM_SEND) {
		p_tx_ipdu_inib = p_ipdu_inib->p_tx_ipdu_inib;
		COM_CHECK_NULL_POINTER(p_tx_ipdu_inib != NULL_PTR, COMServiceId_ipdu_initialize);

		/* [COM015][COM217] IPDUХåե̤ѥǡǽ */
		for (j = 0U; j < p_ipdu_inib->PduLength; j++) {
			(p_ipdu_inib->p_ipdu_buffer)[j] = p_tx_ipdu_inib->ComTxIPduUnusedAreasDefault;
		}

		/* filteringˤOCCURRENCE򥯥ꥢ */
		clear_occurrence(p_ipdu_inib);

		for (i = 0U; i < p_ipdu_inib->tnum_signal; i++) {
			p_signal_inib = GET_SIGNAL_INIB((p_ipdu_inib->p_signalid_list)[i]);

			/* [COM217] IPDUХåեComSignalInitValueꤹ */
			packing(p_signal_inib, p_signal_inib->ComSignalInitValue);
			/* [COM228] ʥХåեComSignalInitValueǼ */
			set_tx_signal(p_signal_inib, p_signal_inib->ComSignalInitValue);
			/* [COM603][COM604] ե륿ХåեComSignalInitValueǼ */
			set_filter_buffer(p_signal_inib, p_signal_inib->ComSignalInitValue);

			/* tmc */
			if (p_signal_inib->ComFilterAlgorithm != COM_INVALID_UINT8) {
				p_tx_signal_cb = (TX_SIGNAL_CB *) p_signal_inib->p_signal_cb;
				COM_CHECK_NULL_POINTER(p_tx_signal_cb != NULL_PTR, COMServiceId_ipdu_initialize);

				p_tx_signal_cb->tmc = filtering(p_signal_inib, p_signal_inib->ComSignalInitValue);
			}
		}

		/* [COM217] åץǡȥӥåȥꥢ */
		clear_updatebit(p_ipdu_inib);

		/* ⡼ */
		set_tx_mode(p_ipdu_inib, check_tms(p_ipdu_inib));
	}
	else {
		for (i = 0U; i < p_ipdu_inib->tnum_signal; i++) {
			p_signal_inib = GET_SIGNAL_INIB((p_ipdu_inib->p_signalid_list)[i]);

			/* ʥХåեComSignalInitValueǼ */
			set_rx_signal(p_signal_inib, p_signal_inib->ComSignalInitValue);

			/* [COM603] ե륿ХåեComSignalInitValueǼ */
			set_filter_buffer(p_signal_inib, p_signal_inib->ComSignalInitValue);
		}

		/* OCCURRENCE򥯥ꥢ */
		clear_occurrence(p_ipdu_inib);

		/* DM */
		stop_rx_dm(p_ipdu_inib);
	}

	/* [COM778] IPDU_STARTED_BITʳ򥯥ꥢ */
	IPDU_CLEAR_EXCEPT_STARTED(p_ipdu_inib->p_state);

  error_exit:
	return;
}

/*
 *  OCCURRENCEꥢ
 */
LOCAL_INLINE void
clear_occurrence(const IPDU_INIB *p_ipdu_inib)
{
	const SIGNAL_INIB				*p_signal_inib;
	const FILTER_ONE_EVERY_N_INIB	*p_filter_one_every_n_inib;
	Com_SignalIdType				i;

	COM_CHECK_NULL_POINTER(p_ipdu_inib != NULL_PTR, COMServiceId_clear_occurrence);

	for (i = 0U; i < p_ipdu_inib->tnum_signal; i++) {
		p_signal_inib = GET_SIGNAL_INIB((p_ipdu_inib->p_signalid_list)[i]);
		COM_CHECK_NULL_POINTER(p_signal_inib != NULL_PTR, COMServiceId_clear_occurrence);

		/* COM_ONE_EVERY_NΥե륿ĥʥǤΤ߽ */
		if (p_signal_inib->ComFilterAlgorithm == COM_ONE_EVERY_N) {
			p_filter_one_every_n_inib = (const FILTER_ONE_EVERY_N_INIB *) p_signal_inib->p_filter_inib;
			COM_CHECK_NULL_POINTER((p_filter_one_every_n_inib != NULL_PTR) &&
									(p_filter_one_every_n_inib->p_occur != NULL_PTR), COMServiceId_clear_occurrence);

			/* [COM231] OCCURRENCE0ꤹ */
			*(p_filter_one_every_n_inib->p_occur) = 0U;
		}
	}

  error_exit:
	return;
}

/*
 *  ե륿󥰽
 *  [COM132][COM674] դǡФƤե륿󥰤Ԥ
 */
static boolean
filtering(const SIGNAL_INIB *p_signal_inib, const void *p_data)
{
	const void		*p_filter_inib;
	boolean			result = FALSE;
	uint32			new_uint_data;
	uint32			old_uint_data;
	sint32			new_sint_data;
	sint32			old_sint_data;

	/* [COM325] ٤ƤΥե륿르ꥺ򥵥ݡ */
	if (p_signal_inib->ComFilterAlgorithm == COM_ALWAYS) {
		result = TRUE;
	}
	else if (p_signal_inib->ComFilterAlgorithm == COM_NEVER) {
		result = FALSE;
	}
	else {
		COM_CHECK_PARAM((p_signal_inib->ComSignalType >= COM_BOOLEAN) &&
						(p_signal_inib->ComSignalType <= COM_SINT32) &&
						(p_signal_inib->p_filter_inib != NULL_PTR), COMServiceId_filtering);

		/*
		 *  [COM319] COM_FLOAT32COM_FLOAT64Υʥξ硤ե륿ʤ
		 *  [COM380] COM_UINT8_NΥʥ뤬ե륿ľ硤ComFilterAlgorithmCOM_NEVERޤCOM_ALWAYSǤ
		 */

		p_filter_inib = p_signal_inib->p_filter_inib;
		switch (p_signal_inib->ComFilterAlgorithm) {
		case COM_MASKED_NEW_EQUALS_X:
			if ((p_signal_inib->ComSignalType >= COM_BOOLEAN) && (p_signal_inib->ComSignalType <= COM_UINT32)) {
				new_uint_data = copy_signal_to_uint32(p_signal_inib, p_data);
				/* ComSignalTypeUINTϤξ硤FILTER_UINT_MASKED_INIB˥㥹Ȥ */
				if ((new_uint_data & ((const FILTER_UINT_MASKED_INIB *) p_filter_inib)->ComFilterMask) == ((const FILTER_UINT_MASKED_INIB *) p_filter_inib)->ComFilterX) {
					result = TRUE;
				}
			}
			else {
				new_sint_data = cast_signal_to_sint32(p_signal_inib, p_data);
				/* ComSignalTypeSINTϤξ硤FILTER_SINT_MASKED_INIB˥㥹Ȥ */
				if ((new_sint_data & ((const FILTER_SINT_MASKED_INIB *) p_filter_inib)->ComFilterMask) == ((const FILTER_SINT_MASKED_INIB *) p_filter_inib)->ComFilterX) {
					result = TRUE;
				}
			}
			break;
		case COM_MASKED_NEW_DIFFERS_X:
			if ((p_signal_inib->ComSignalType >= COM_BOOLEAN) && (p_signal_inib->ComSignalType <= COM_UINT32)) {
				new_uint_data = copy_signal_to_uint32(p_signal_inib, p_data);
				/* ComSignalTypeUINTϤξ硤FILTER_UINT_MASKED_INIB˥㥹Ȥ */
				if ((new_uint_data & ((const FILTER_UINT_MASKED_INIB *) p_filter_inib)->ComFilterMask) != ((const FILTER_UINT_MASKED_INIB *) p_filter_inib)->ComFilterX) {
					result = TRUE;
				}
			}
			else {
				new_sint_data = cast_signal_to_sint32(p_signal_inib, p_data);
				/* ComSignalTypeSINTϤξ硤FILTER_SINT_MASKED_INIB˥㥹Ȥ */
				if ((new_sint_data & ((const FILTER_SINT_MASKED_INIB *) p_filter_inib)->ComFilterMask) != ((const FILTER_SINT_MASKED_INIB *) p_filter_inib)->ComFilterX) {
					result = TRUE;
				}
			}
			break;
		case COM_MASKED_NEW_DIFFERS_MASKED_OLD:
			if ((p_signal_inib->ComSignalType >= COM_BOOLEAN) && (p_signal_inib->ComSignalType <= COM_UINT32)) {
				new_uint_data = copy_signal_to_uint32(p_signal_inib, p_data);
				/* ComSignalTypeUINTϤξ硤FILTER_UINT_MASKED_OLD_INIB˥㥹Ȥ */
				old_uint_data = copy_signal_to_uint32(p_signal_inib, ((const FILTER_UINT_MASKED_OLD_INIB *) p_filter_inib)->p_filter_buffer);
				/* [COM763] */
				if ((new_uint_data & ((const FILTER_UINT_MASKED_OLD_INIB *) p_filter_inib)->ComFilterMask) != (old_uint_data & ((const FILTER_UINT_MASKED_OLD_INIB *) p_filter_inib)->ComFilterMask)) {
					result = TRUE;

					/* [COM302][COM303] */
					set_filter_buffer(p_signal_inib, p_data);
				}
			}
			else {
				new_sint_data = cast_signal_to_sint32(p_signal_inib, p_data);
				/* ComSignalTypeSINTϤξ硤FILTER_SINT_MASKED_OLD_INIB˥㥹Ȥ */
				old_sint_data = cast_signal_to_sint32(p_signal_inib, ((const FILTER_SINT_MASKED_OLD_INIB *) p_filter_inib)->p_filter_buffer);
				/* [COM763] */
				if ((new_sint_data & ((const FILTER_SINT_MASKED_OLD_INIB *) p_filter_inib)->ComFilterMask) != (old_sint_data & ((const FILTER_SINT_MASKED_OLD_INIB *) p_filter_inib)->ComFilterMask)) {
					result = TRUE;

					/* [COM302][COM303] */
					set_filter_buffer(p_signal_inib, p_data);
				}
			}
			break;
		case COM_NEW_IS_WITHIN:
			if ((p_signal_inib->ComSignalType >= COM_BOOLEAN) && (p_signal_inib->ComSignalType <= COM_UINT32)) {
				new_uint_data = copy_signal_to_uint32(p_signal_inib, p_data);
				/* ComSignalTypeUINTϤξ硤FILTER_UINT_NEW_IS_INIB˥㥹Ȥ */
				if ((((const FILTER_UINT_NEW_IS_INIB *) p_filter_inib)->ComFilterMin <= new_uint_data) && (new_uint_data <= ((const FILTER_UINT_NEW_IS_INIB *) p_filter_inib)->ComFilterMax)) {
					result = TRUE;
				}
			}
			else {
				new_sint_data = cast_signal_to_sint32(p_signal_inib, p_data);
				/* ComSignalTypeSINTϤξ硤FILTER_SINT_NEW_IS_INIB˥㥹Ȥ */
				if ((((const FILTER_SINT_NEW_IS_INIB *) p_filter_inib)->ComFilterMin <= new_sint_data) && (new_sint_data <= ((const FILTER_SINT_NEW_IS_INIB *) p_filter_inib)->ComFilterMax)) {
					result = TRUE;
				}
			}
			break;
		case COM_NEW_IS_OUTSIDE:
			if ((p_signal_inib->ComSignalType >= COM_BOOLEAN) && (p_signal_inib->ComSignalType <= COM_UINT32)) {
				new_uint_data = copy_signal_to_uint32(p_signal_inib, p_data);
				/* ComSignalTypeUINTϤξ硤FILTER_UINT_NEW_IS_INIB˥㥹Ȥ */
				if ((new_uint_data < ((const FILTER_UINT_NEW_IS_INIB *) p_filter_inib)->ComFilterMin) || (((const FILTER_UINT_NEW_IS_INIB *) p_filter_inib)->ComFilterMax < new_uint_data)) {
					result = TRUE;
				}
			}
			else {
				new_sint_data = cast_signal_to_sint32(p_signal_inib, p_data);
				/* ComSignalTypeSINTϤξ硤FILTER_SINT_NEW_IS_INIB˥㥹Ȥ */
				if ((new_sint_data < ((const FILTER_SINT_NEW_IS_INIB *) p_filter_inib)->ComFilterMin) || (((const FILTER_SINT_NEW_IS_INIB *) p_filter_inib)->ComFilterMax < new_sint_data)) {
					result = TRUE;
				}
			}
			break;
		case COM_ONE_EVERY_N:
			/* [COM231] */
			if (*(((const FILTER_ONE_EVERY_N_INIB *) p_filter_inib)->p_occur) == ((const FILTER_ONE_EVERY_N_INIB *) p_filter_inib)->ComFilterPeriod) {
				*(((const FILTER_ONE_EVERY_N_INIB *) p_filter_inib)->p_occur) = 0U;
			}
			/* COM231ˤꡤʸ(occurrence % period == offset)ƱȤʤ */
			if (*(((const FILTER_ONE_EVERY_N_INIB *) p_filter_inib)->p_occur) == ((const FILTER_ONE_EVERY_N_INIB *) p_filter_inib)->ComFilterOffset) {
				result = TRUE;
			}
			(*(((const FILTER_ONE_EVERY_N_INIB *) p_filter_inib)->p_occur))++;
			break;
		default:
			/*
			 *  ܴؿΰCOM_MASKED_NEW_EQUALS_XCOM_MASKED_NEW_DIFFERS_XCOM_MASKED_NEW_DIFFERS_MASKED_OLDCOM_NEW_IS_WITHIN
			 *  COM_NEW_IS_OUTSIDECOM_ONE_EVERY_NCOM_NEVERCOM_ALWAYSCOM_INVALID_UINT8ʳꤵ뤳ȤϤʤ
			 */
			COM_CHECK_PARAM(FALSE, COMServiceId_filtering);
			break;
		}
	}

  error_exit:
	/* [COM694] */
	return(result);
}

/*
 * ե륿ХåեʥǡǼ()
 */
LOCAL_INLINE void
set_filter_buffer(const SIGNAL_INIB	*p_signal_inib, const void *p_data)
{
	const void *p_filter_inib;

	/* COM_MASKED_NEW_DIFFERS_MASKED_OLDͤѤʤ */
	if (p_signal_inib->ComFilterAlgorithm == COM_MASKED_NEW_DIFFERS_MASKED_OLD) {
		p_filter_inib = p_signal_inib->p_filter_inib;
		COM_CHECK_PARAM(p_filter_inib != NULL_PTR, COMServiceId_set_filter_buffer);
		switch (p_signal_inib->ComSignalType) {
		case COM_BOOLEAN:
			COM_CHECK_PARAM(((const FILTER_UINT_MASKED_OLD_INIB *) p_filter_inib)->p_filter_buffer != NULL_PTR, COMServiceId_set_filter_buffer);
			*((boolean *) ((const FILTER_UINT_MASKED_OLD_INIB *) p_filter_inib)->p_filter_buffer) = *((const boolean *) p_data);
			break;
		case COM_SINT8:
			COM_CHECK_PARAM(((const FILTER_SINT_MASKED_OLD_INIB *) p_filter_inib)->p_filter_buffer != NULL_PTR, COMServiceId_set_filter_buffer);
			*((sint8 *) ((const FILTER_SINT_MASKED_OLD_INIB *) p_filter_inib)->p_filter_buffer) = *((const sint8 *) p_data);
			break;
		case COM_SINT16:
			COM_CHECK_PARAM(((const FILTER_SINT_MASKED_OLD_INIB *) p_filter_inib)->p_filter_buffer != NULL_PTR, COMServiceId_set_filter_buffer);
			*((sint16 *) ((const FILTER_SINT_MASKED_OLD_INIB *) p_filter_inib)->p_filter_buffer) = *((const sint16 *) p_data);
			break;
		case COM_SINT32:
			COM_CHECK_PARAM(((const FILTER_SINT_MASKED_OLD_INIB *) p_filter_inib)->p_filter_buffer != NULL_PTR, COMServiceId_set_filter_buffer);
			*((sint32 *) ((const FILTER_SINT_MASKED_OLD_INIB *) p_filter_inib)->p_filter_buffer) = *((const sint32 *) p_data);
			break;
		case COM_UINT8:
			COM_CHECK_PARAM(((const FILTER_UINT_MASKED_OLD_INIB *) p_filter_inib)->p_filter_buffer != NULL_PTR, COMServiceId_set_filter_buffer);
			*((uint8 *) ((const FILTER_UINT_MASKED_OLD_INIB *) p_filter_inib)->p_filter_buffer) = *((const uint8 *) p_data);
			break;
		case COM_UINT16:
			COM_CHECK_PARAM(((const FILTER_UINT_MASKED_OLD_INIB *) p_filter_inib)->p_filter_buffer != NULL_PTR, COMServiceId_set_filter_buffer);
			*((uint16 *) ((const FILTER_UINT_MASKED_OLD_INIB *) p_filter_inib)->p_filter_buffer) = *((const uint16 *) p_data);
			break;
		case COM_UINT32:
			COM_CHECK_PARAM(((const FILTER_UINT_MASKED_OLD_INIB *) p_filter_inib)->p_filter_buffer != NULL_PTR, COMServiceId_set_filter_buffer);
			*((uint32 *) ((const FILTER_UINT_MASKED_OLD_INIB *) p_filter_inib)->p_filter_buffer) = *((const uint32 *) p_data);
			break;
		default:
			/*
			 *  ܴؿΰCOM_UINT8_NCOM_FLOAT32COM_FLOAT64ꤵ뤳ȤϤʤ
			 *  [COM380] COM_UINT8_NΥʥ뤬ե륿ľ硤ComFilterAlgorithmCOM_NEVERޤCOM_ALWAYSǤ
			 *  [COM319] COM_FLOAT32COM_FLOAT64Υʥξ硤ե륿ʤ
			 */
			COM_CHECK_PARAM(FALSE, COMServiceId_set_filter_buffer);
			break;
		}
	}

  error_exit:
	return;
}

/*
 *  ƥǡuint32إԡ
 */
LOCAL_INLINE uint32
copy_signal_to_uint32(const SIGNAL_INIB *p_signal_inib, const void *p_data)
{
	uint32 signal_data;

	switch (p_signal_inib->ComSignalType) {
	case COM_BOOLEAN:
		signal_data = (uint32) (*((const boolean *) p_data));
		break;
	case COM_SINT8:
		signal_data = (uint32) ((sint32) (*((const sint8 *) p_data)));
		break;
	case COM_SINT16:
		signal_data = (uint32) ((sint32) (*((const sint16 *) p_data)));
		break;
	case COM_SINT32:
		signal_data = *((const uint32 *) p_data);
		break;
	case COM_UINT8:
		signal_data = (uint32) (*((const uint8 *) p_data));
		break;
	case COM_UINT16:
		signal_data = (uint32) (*((const uint16 *) p_data));
		break;
	case COM_UINT32:
		signal_data = *((const uint32 *) p_data);
		break;
	case COM_FLOAT32:
		signal_data = *((const uint32 *) p_data);
		break;
	default:
		/* uninitializedٹ޻ */
		signal_data = 0U;
		/*
		 *  ܴؿΰCOM_FLOAT64ꤵ뤳ȤϤʤ
		 *  packingؿǤϡifCOM_FLOAT64ʬƤ
		 */
		COM_CHECK_PARAM(FALSE, COMServiceId_copy_signal_to_uint32);
		break;
	}

  error_exit:
	return(signal_data);
}

/*
 *  ƥǡsint32إ㥹Ȥ
 */
LOCAL_INLINE sint32
cast_signal_to_sint32(const SIGNAL_INIB *p_signal_inib, const void *p_data)
{
	sint32 signal_data;

	switch (p_signal_inib->ComSignalType) {
	case COM_SINT8:
		signal_data = (sint32) (*((const sint8 *) p_data));
		break;
	case COM_SINT16:
		signal_data = (sint32) (*((const sint16 *) p_data));
		break;
	case COM_SINT32:
		signal_data = (*((const sint32 *) p_data));
		break;
	default:
		/* uninitializedٹ޻ */
		signal_data = 0;
		/*
		 *  ܴؿΰCOM_BOOLEANCOM_UINT8COM_UINT16COM_UINT32COM_FLOAT32COM_FLOAT64ꤵ뤳ȤϤʤ
		 *  [COM319] filteringؿǤϡfloatѤʤ
		 */
		COM_CHECK_PARAM(FALSE, COMServiceId_cast_signal_to_sint32);
		break;
	}

  error_exit:
	return(signal_data);
}


/*
 *  
 */
LOCAL_INLINE void
send_ipdu(const IPDU_INIB *p_ipdu_inib)
{
	const TX_MODE_INIB		*p_tx_mode_inib;
	TX_IPDU_CB				*p_tx_ipdu_cb;
	Std_ReturnType			send_flg;
	boolean					direct_req;
	boolean					periodic_req;
	boolean					trigger_req;
	boolean					send_req = FALSE;

	p_tx_ipdu_cb = (TX_IPDU_CB *) p_ipdu_inib->p_ipdu_cb;
	p_tx_mode_inib = p_tx_ipdu_cb->p_cur_tx_mode_inib;

	/* ⡼Ƚ */
	switch (p_tx_mode_inib->ComTxModeMode) {
	/* [COM305] COM_DIRECT */
	case COM_DIRECT:
		direct_req = TRUE;
		periodic_req = FALSE;
		break;
	/* COM_PERIODIC */
	case COM_PERIODIC:
		direct_req = FALSE;
		periodic_req = TRUE;
		break;
	/* [COM305] COM_MIXED */
	case COM_MIXED:
		direct_req = TRUE;
		periodic_req = TRUE;
		break;
	/* [COM135] COM_NONE */
	default:
		direct_req = FALSE;
		periodic_req = FALSE;
		break;
	}

	/* ȥꥬȽ */
	if (IPDU_IS_TRIGGERED(p_ipdu_inib->p_state)) {
		IPDU_CLEAR_TRIGGERED(p_ipdu_inib->p_state);
		trigger_req = TRUE;
	}
	else {
		trigger_req = FALSE;
	}

	/* Ƚ */
	if (IPDU_IS_MDT_WAIT(p_ipdu_inib->p_state)) {
		send_req = TRUE;
	}
#if COM_RETRY_FAILED_TRANSMIT_REQUESTS == STD_ON
	if (IPDU_IS_RETRY(p_ipdu_inib->p_state)) {
		send_req = TRUE;
	}
#endif
	if (direct_req != FALSE) {
		if (p_tx_ipdu_cb->interval_mf_cnt > 0U) {
			p_tx_ipdu_cb->interval_mf_cnt--;
		}
		/* ֳ֤MF󥿤0ξ */
		if (IPDU_IS_DIRECT_SEND(p_ipdu_inib->p_state) && (p_tx_ipdu_cb->interval_mf_cnt == 0U)) {
			send_req = TRUE;
		}
		else {
			/* DIRECT륿ߥ󥰤ǤϤʤ */
			direct_req = FALSE;
		}
	}
	if (periodic_req != FALSE) {
		if (p_tx_ipdu_cb->period_mf_cnt > 0U) {
			p_tx_ipdu_cb->period_mf_cnt--;
		}
		/* MF󥿤0ξ */
		if (p_tx_ipdu_cb->period_mf_cnt == 0U) {
			/* [COM776] ֤ΰѤʤ */
			p_tx_ipdu_cb->period_mf_cnt = p_tx_ipdu_cb->p_cur_tx_mode_inib->ComTxModeTimePeriod;
			send_req = TRUE;
		}
		else {
			/* PERIODIC륿ߥ󥰤ǤϤʤ */
			periodic_req = FALSE;
		}
	}
	if (trigger_req != FALSE) {
		send_req = TRUE;
	}

	/*  */
	if (send_req != FALSE) {
		/* [COM582][COM478][COM388] IPDU */
		/* [COM494] ľȼΥߥ󥰤Ťʤä1 */
		send_flg = send_ipdu_respect_mdt(p_ipdu_inib);

		/* Ƚ */
		if (send_flg == E_OK) {
			if (direct_req != FALSE) {
				/* ֤ĤäƤ */
				if (p_tx_ipdu_cb->repeat_cnt != 0U) {
					p_tx_ipdu_cb->interval_mf_cnt = p_tx_ipdu_cb->p_cur_tx_mode_inib->ComTxModeRepetitionPeriod;
				}
				else {
					IPDU_CLEAR_DIRECT_SEND(p_ipdu_inib->p_state);
				}
			}
		}
	}
}

/*
 *  PduRؤ
 *  [COM495] PduRؤɬsend_ipdu_respect_mdtѤ뤿ᡤTMSػMDTθ
 */
LOCAL_INLINE Std_ReturnType
send_ipdu_respect_mdt(const IPDU_INIB *p_ipdu_inib)
{
	const Com_ConfigType	*p_saved_config;
	TX_IPDU_CB				*p_tx_ipdu_cb;
	uint8					*p_pdubuffer;
	Com_IpduCallout			callout;
	PduInfoType				pduinfo;
	Std_ReturnType			ret_transmit;
	boolean					ret_callout;
	PduIdType				pduid;

	p_tx_ipdu_cb = (TX_IPDU_CB *) p_ipdu_inib->p_ipdu_cb;

	/* [COM625] */
	if (p_tx_ipdu_cb->mdt_mf_cnt == 0U) {
		/* [COM346][COM719] 륢Ƚ */
		if (p_ipdu_inib->ComIPduCallout != NULL_PTR) {
			/* ¾ꥢǳƾФ */
			callout = p_ipdu_inib->ComIPduCallout;
			pduid = p_ipdu_inib->PduRSourcePduHandleId;
			p_pdubuffer = p_ipdu_inib->p_ipdu_buffer;

			/* ƽåѤ˸ߤΥե졼ݻ */
			p_saved_config = p_cur_com_config;

			/* [COM381] Com_TriggerIPDUSend, Com_SendSignalϥ륢ȤƽФǽȤ */
			SchM_Exit_Com_Reentrant_0();
			ret_callout = callout(pduid, p_pdubuffer);
			SchM_Enter_Com_Reentrant_0();

			/* ¾ꥢǥե졼ѲƤʤå */
			COM_CHECK_PARAM(p_saved_config == p_cur_com_config, COMServiceId_mdt_send);

			if (ret_callout == FALSE) {
				ret_transmit = E_OK;
				/* [COMa004] FALSEξ硤ʹߤν»ܤʤ */
				goto no_error_exit;
			}
		}

		/* IPDU */
		pduinfo.SduDataPtr = p_ipdu_inib->p_ipdu_buffer;
		pduinfo.SduLength = p_ipdu_inib->PduLength;

		/* [COM138][COM239] IPDU */
		ret_transmit = PduR_ComTransmit(p_ipdu_inib->PduRSourcePduHandleId, &pduinfo);

		/* PduR_ComTransmit򥳡뤷顤MDTԤϲ */
		IPDU_CLEAR_MDT_WAIT(p_ipdu_inib->p_state);

		if (ret_transmit == E_OK) {
			/* IPDUΤMDTꤹ */
			set_mdt(p_ipdu_inib);
#if COM_RETRY_FAILED_TRANSMIT_REQUESTS == STD_ON
			/* E_OKǤСȥ饤ϲ */
			IPDU_CLEAR_RETRY(p_ipdu_inib->p_state);
#endif
			/* 塼󥰤(0xFF) */
			if (p_tx_ipdu_cb->queuing_cnt != COM_INVALID_UINT8) {
				p_tx_ipdu_cb->queuing_cnt++;
			}

			/* [COM062] åץǡȥӥåȥꥢ */
			if (p_ipdu_inib->p_tx_ipdu_inib->ComTxIPduClearUpdateBit == COM_TRANSMIT) {
				clear_updatebit(p_ipdu_inib);
			}
		}
		else {
#if COM_RETRY_FAILED_TRANSMIT_REQUESTS == STD_ON
			/* [COM773][COM779] Ԥ׵Υȥ饤 */
			IPDU_SET_RETRY(p_ipdu_inib->p_state);
#endif
		}
	}
	else {
		IPDU_SET_MDT_WAIT(p_ipdu_inib->p_state);
		ret_transmit = E_NOT_OK;
	}

	/* DM */
	start_tx_dm(p_ipdu_inib);

  no_error_exit:
	return(ret_transmit);

  error_exit:
	ret_transmit = E_NOT_OK;
	goto no_error_exit;
}

/*
 *  MDT󥿤򥻥å
 */
LOCAL_INLINE void
set_mdt(const IPDU_INIB *p_ipdu_inib)
{
	const TX_IPDU_INIB	*p_tx_ipdu_inib;
	TX_IPDU_CB			*p_tx_ipdu_cb;

	p_tx_ipdu_cb = (TX_IPDU_CB *) p_ipdu_inib->p_ipdu_cb;
	p_tx_ipdu_inib = p_ipdu_inib->p_tx_ipdu_inib;

#if COM_ENABLE_MDT_FOR_CYCLIC_TRANSMISSION == STD_OFF
	/* [COM789][COM698] DIRECTΰܤΤMDTƻ뤹 */
	if (IPDU_IS_FIRST_DIRECT_SEND(p_ipdu_inib->p_state)) {
		p_tx_ipdu_cb->mdt_mf_cnt = p_tx_ipdu_inib->ComMinimumDelayTime;
	}
	else {
		/* [COM471] MDT 0ξMDTƻ뤷ʤ */
		p_tx_ipdu_cb->mdt_mf_cnt = 0U;
	}
#else
	p_tx_ipdu_cb->mdt_mf_cnt = p_tx_ipdu_inib->ComMinimumDelayTime;
#endif

	return;
}

/*
 *  DM
 */
LOCAL_INLINE void
start_tx_dm(const IPDU_INIB *p_ipdu_inib)
{
	const SIGNAL_INIB	*p_signal_inib;
	TX_IPDU_CB			*p_tx_ipdu_cb;

	/* ʥͼ ComTimeoutͤƱIPDUΥʥѲϤʤΤǺǽΥʥͤ */
	p_signal_inib = GET_SIGNAL_INIB((p_ipdu_inib->p_signalid_list)[0]);
	p_tx_ipdu_cb = (TX_IPDU_CB *) p_ipdu_inib->p_ipdu_cb;

	if (!IPDU_IS_DM(p_ipdu_inib->p_state)) {
		/* [COM333] ComTimeout0ޤϡάƤ硤ΥʥDMƻϤʤ */
		if (p_signal_inib->ComTimeout != 0U) {
			/* [COM481][COM774] */
			IPDU_SET_DM(p_ipdu_inib->p_state);
			p_tx_ipdu_cb->dm_mf_cnt = p_signal_inib->ComTimeout;
		}
	}

	return;
}

/*
 *  ʥѥå
 *  [COM007][COM580] ǥѴ
 */
LOCAL_INLINE void
packing(const SIGNAL_INIB *p_signal_inib, const void *p_data)
{
	const IPDU_INIB	*p_ipdu_inib;
	const uint8		*p_signal_data;     /* ʥǡΥݥ */
	PduLengthType	byte_index;         /* LSBByte */
	uint8			pos_lsb;            /* LSBBit */
	uint16			i;
	uint32			signal_data;        /* ʥǡ */
#ifdef INT64_MAX
	uint32			low_signal_data;    /* COM_FLOAT64ξ硤ʥǡ32bit */
	uint32			high_signal_data;   /* COM_FLOAT64ξ硤ʥǡ32bit */
#endif /* INT64_MAX */

	p_ipdu_inib = p_signal_inib->p_ipdu_inib;
	byte_index = p_signal_inib->ComBitPositionLsb / 8U;
	pos_lsb = (uint8) (p_signal_inib->ComBitPositionLsb % 8U);

	COM_CHECK_PARAM((p_signal_inib->ComSignalEndianness >= COM_BIG_ENDIAN) &&
					(p_signal_inib->ComSignalEndianness <= COM_OPAQUE), COMServiceId_packing);
#ifdef INT64_MAX
	COM_CHECK_PARAM((p_signal_inib->ComSignalType >= COM_BOOLEAN) &&
					(p_signal_inib->ComSignalType <= COM_FLOAT64), COMServiceId_packing);
#else
	COM_CHECK_PARAM((p_signal_inib->ComSignalType >= COM_BOOLEAN) &&
					(p_signal_inib->ComSignalType <= COM_FLOAT32), COMServiceId_packing);
#endif /* INT64_MAX */

	if (p_signal_inib->ComSignalEndianness == COM_OPAQUE) {
		/* COM_OPAQUEξ硤LSB8ܿǤʤФʤʤ */
		COM_CHECK_PARAM(pos_lsb == 0U, COMServiceId_packing);

		p_signal_data = (const uint8 *) p_data;

		/* [COM443][COM472] COM_OPAQUECOM_UINT8_NΤ */
		for (i = 0U; i < p_signal_inib->ComSignalLength; i++) {
			/* IPDUХåե˥ʥǡǼ */
			(p_ipdu_inib->p_ipdu_buffer)[byte_index] = p_signal_data[i];

			/* [COM259_Conf] COM_OPAQUECOM_LITTLE_ENDIANȤ */
			byte_index++;
		}
	}
	else {
#ifdef INT64_MAX
		if (p_signal_inib->ComSignalType == COM_FLOAT64) {
			/* 32bit */
			low_signal_data = (uint32) ((*(const uint64 *) p_data) & ((uint32) 0xFFFFFFFF));

			/* 32bit */
			high_signal_data = (uint32) (((*(const uint64 *) p_data) >> 32U) & ((uint32) 0xFFFFFFFF));

			if (p_signal_inib->ComSignalEndianness == COM_LITTLE_ENDIAN) {
				pack_little_endian(p_ipdu_inib->p_ipdu_buffer, byte_index, pos_lsb, 32U, low_signal_data);
				pack_little_endian(p_ipdu_inib->p_ipdu_buffer, byte_index + 4U, pos_lsb, 32U, high_signal_data);
			}
			else {
				pack_big_endian(p_ipdu_inib->p_ipdu_buffer, byte_index, pos_lsb, 32U, low_signal_data);
				pack_big_endian(p_ipdu_inib->p_ipdu_buffer, byte_index - 4U, pos_lsb, 32U, high_signal_data);
			}
		}
		else {
#endif /* INT64_MAX */
			/* ǡоݥǡѴ */
			signal_data = copy_signal_to_uint32(p_signal_inib, p_data);

			if (p_signal_inib->ComSignalEndianness == COM_LITTLE_ENDIAN) {
				pack_little_endian(p_ipdu_inib->p_ipdu_buffer, byte_index, pos_lsb, p_signal_inib->ComBitSize, signal_data);
			}
			else {
				pack_big_endian(p_ipdu_inib->p_ipdu_buffer, byte_index, pos_lsb, p_signal_inib->ComBitSize, signal_data);
			}
#ifdef INT64_MAX
		}
#endif /* INT64_MAX */
	}

  error_exit:
	return;
}

/*
 *  ʥѥå ȥ륨ǥѴ
 */
LOCAL_INLINE void
pack_little_endian(uint8 p_buffer[], PduLengthType byte_index, uint8 pos_lsb, uint8 bitsize, uint32 signal_data)
{
	uint8	mask;
	uint8	pos_msb;    /* MSBBit */

	/* ǼϰϤ1ByteǤ */
	if ((pos_lsb + bitsize) <= 8U) {
		pos_msb = (pos_lsb + bitsize) - 1U;
		mask = ((uint8) (0xFFU << pos_lsb)) & (0xFFU >> ((uint8) (7U - pos_msb)));

		/* IPDUХåե˥ʥǡǼ */
		p_buffer[byte_index] = (p_buffer[byte_index] & ((uint8) (~mask))) | ((uint8) ((signal_data << pos_lsb) & ((uint32) mask)));
	}
	else {
		mask = (uint8) (0xFFU << pos_lsb);

		/* IPDUХåե˥ʥǡǼ */
		p_buffer[byte_index] = (p_buffer[byte_index] & ((uint8) (~mask))) | ((uint8) ((signal_data << pos_lsb) & ((uint32) mask)));
		signal_data >>= 8U - pos_lsb;
		bitsize -= 8U - pos_lsb;

		byte_index++;

		/* ʥλĤꥵ1ByteʾǤ */
		while (bitsize >= 8U) {
			/* IPDUХåե˥ʥǡǼ */
			p_buffer[byte_index] = (uint8) signal_data;
			signal_data >>= 8U;
			bitsize -= 8U;

			byte_index++;
		}

		/* ʥλĤꥵ */
		if (bitsize != 0U) {
			mask = (uint8) (0xFFU >> (8U - bitsize));
			/* IPDUХåե˥ʥǡǼ */
			p_buffer[byte_index] = (p_buffer[byte_index] & ((uint8) (~mask))) | ((uint8) (signal_data & ((uint32) mask)));
		}
	}

	return;
}

/*
 *  ʥѥå ӥåǥѴ
 */
LOCAL_INLINE void
pack_big_endian(uint8 p_buffer[], PduLengthType byte_index, uint8 pos_lsb, uint8 bitsize, uint32 signal_data)
{
	uint8	mask;
	uint8	pos_msb;    /* MSBBit */

	/* ǼϰϤ1ByteǤ */
	if ((pos_lsb + bitsize) <= 8U) {
		pos_msb = (pos_lsb + bitsize) - 1U;
		mask = ((uint8) (0xFFU << pos_lsb)) & (0xFFU >> ((uint8) (7U - pos_msb)));

		/* IPDUХåե˥ʥǡǼ */
		p_buffer[byte_index] = (p_buffer[byte_index] & ((uint8) (~mask))) | ((uint8) ((signal_data << pos_lsb) & ((uint32) mask)));
	}
	else {
		mask = (uint8) (0xFFU << pos_lsb);

		/* IPDUХåե˥ʥǡǼ */
		p_buffer[byte_index] = (p_buffer[byte_index] & ((uint8) (~mask))) | ((uint8) ((signal_data << pos_lsb) & ((uint32) mask)));
		signal_data >>= 8U - pos_lsb;
		bitsize -= 8U - pos_lsb;

		byte_index--;

		/* ʥλĤꥵ1ByteʾǤ */
		while (bitsize >= 8U) {
			/* IPDUХåե˥ʥǡǼ */
			p_buffer[byte_index] = (uint8) signal_data;
			signal_data >>= 8U;
			bitsize -= 8U;

			byte_index--;
		}

		/* ʥλĤꥵ */
		if (bitsize != 0U) {
			mask = (uint8) (0xFFU >> (8U - bitsize));
			/* IPDUХåե˥ʥǡǼ */
			p_buffer[byte_index] = (p_buffer[byte_index] & ((uint8) (~mask))) | ((uint8) (signal_data & ((uint32) mask)));
		}
	}

	return;
}

/*
 *  åץǡȥӥå
 */
LOCAL_INLINE void
set_updatebit(const SIGNAL_INIB *p_signal_inib)
{
	const IPDU_INIB	*p_ipdu_inib;

	if (p_signal_inib->ComUpdateBitPosition != COM_INVALID_UINT16) {
		p_ipdu_inib = p_signal_inib->p_ipdu_inib;
		/* [COM059] 0:ʤ1: */
		(p_ipdu_inib->p_ipdu_buffer)[p_signal_inib->ComUpdateBitPosition / 8U] |= (uint8) (1U << (p_signal_inib->ComUpdateBitPosition % 8U));
	}

	return;
}

/*
 *  åץǡȥӥåȥꥢ
 */
LOCAL_INLINE void
clear_updatebit(const IPDU_INIB *p_ipdu_inib)
{
	const SIGNAL_INIB	*p_signal_inib;
	Com_SignalIdType	i;

	COM_CHECK_NULL_POINTER(p_ipdu_inib != NULL_PTR, COMServiceId_clear_updatebit);

	for (i = 0U; i < p_ipdu_inib->tnum_signal; i++) {
		p_signal_inib = GET_SIGNAL_INIB((p_ipdu_inib->p_signalid_list)[i]);
		COM_CHECK_NULL_POINTER((p_signal_inib != NULL_PTR) &&
								(p_ipdu_inib->p_ipdu_buffer != NULL_PTR), COMServiceId_clear_updatebit);

		if (p_signal_inib->ComUpdateBitPosition != COM_INVALID_UINT16) {
			/* [COM059] 0:ʤ1: */
			(p_ipdu_inib->p_ipdu_buffer)[p_signal_inib->ComUpdateBitPosition / 8U] &= (uint8) (~((uint8) (1U << (p_signal_inib->ComUpdateBitPosition % 8U))));
		}
	}

  error_exit:
	return;
}

/*
 *  ʥǡͤ
 */
LOCAL_INLINE boolean
check_tx_signal(const SIGNAL_INIB *p_signal_inib, const void *p_data)
{
	boolean	ret = FALSE;
	uint16	i;

	/* ʥХåեפʾӤʤ */
	if (p_signal_inib->p_signal_buffer != NULL_PTR) {
		switch (p_signal_inib->ComSignalType) {
		case COM_BOOLEAN:
			if (*((boolean *) p_signal_inib->p_signal_buffer) != *((const boolean *) p_data)) {
				ret = TRUE;
			}
			break;
		case COM_SINT8:
			if (*((sint8 *) p_signal_inib->p_signal_buffer) != *((const sint8 *) p_data)) {
				ret = TRUE;
			}
			break;
		case COM_SINT16:
			if (*((sint16 *) p_signal_inib->p_signal_buffer) != *((const sint16 *) p_data)) {
				ret = TRUE;
			}
			break;
		case COM_SINT32:
			if (*((sint32 *) p_signal_inib->p_signal_buffer) != *((const sint32 *) p_data)) {
				ret = TRUE;
			}
			break;
		case COM_UINT8:
			if (*((uint8 *) p_signal_inib->p_signal_buffer) != *((const uint8 *) p_data)) {
				ret = TRUE;
			}
			break;
		case COM_UINT16:
			if (*((uint16 *) p_signal_inib->p_signal_buffer) != *((const uint16 *) p_data)) {
				ret = TRUE;
			}
			break;
		case COM_UINT32:
			if (*((uint32 *) p_signal_inib->p_signal_buffer) != *((const uint32 *) p_data)) {
				ret = TRUE;
			}
			break;
		case COM_UINT8_N:
			for (i = 0U; i < p_signal_inib->ComSignalLength; i++) {
				if ((((uint8 *) p_signal_inib->p_signal_buffer)[i]) != (((const uint8 *) p_data)[i])) {
					ret = TRUE;
					break;
				}
			}
			break;
		case COM_FLOAT32:
			if (*((float32 *) p_signal_inib->p_signal_buffer) != *((const float32 *) p_data)) {
				ret = TRUE;
			}
			break;
#ifdef INT64_MAX
		case COM_FLOAT64:
			if (*((float64 *) p_signal_inib->p_signal_buffer) != *((const float64 *) p_data)) {
				ret = TRUE;
			}
			break;
#endif /* INT64_MAX */
		default:
			/*
			 *  ܴؿΰCOM_BOOLEANCOM_SINT8COM_SINT16COM_SINT32COM_UINT8COM_UINT16
			 *  COM_UINT32COM_UINT8_NCOM_FLOAT32COM_FLOAT64ʳꤵ뤳ȤϤʤ
			 */
			COM_CHECK_PARAM(FALSE, COMServiceId_changed_signal);
			break;
		}
	}
	else {
		ret = TRUE;
	}

  error_exit:
	return(ret);
}

/*
 *  ʥХåեؤΥʥǡǼ()
 */
LOCAL_INLINE void
set_tx_signal(const SIGNAL_INIB *p_signal_inib, const void *p_data)
{
	uint16 i;

	/* ʥХåեפʥʥˤϳǼʤ */
	if (p_signal_inib->p_signal_buffer != NULL_PTR) {
		/* [COM353]¦Ǥĥʤ */
		switch (p_signal_inib->ComSignalType) {
		case COM_BOOLEAN:
			*((boolean *) p_signal_inib->p_signal_buffer) = *((const boolean *) p_data);
			break;
		case COM_SINT8:
			*((sint8 *) p_signal_inib->p_signal_buffer) = *((const sint8 *) p_data);
			break;
		case COM_SINT16:
			*((sint16 *) p_signal_inib->p_signal_buffer) = *((const sint16 *) p_data);
			break;
		case COM_SINT32:
			*((sint32 *) p_signal_inib->p_signal_buffer) = *((const sint32 *) p_data);
			break;
		case COM_UINT8:
			*((uint8 *) p_signal_inib->p_signal_buffer) = *((const uint8 *) p_data);
			break;
		case COM_UINT16:
			*((uint16 *) p_signal_inib->p_signal_buffer) = *((const uint16 *) p_data);
			break;
		case COM_UINT32:
			*((uint32 *) p_signal_inib->p_signal_buffer) = *((const uint32 *) p_data);
			break;
		case COM_UINT8_N:
			for (i = 0U; i < p_signal_inib->ComSignalLength; i++) {
				((uint8 *) p_signal_inib->p_signal_buffer)[i] = ((const uint8 *) p_data)[i];
			}
			break;
		case COM_FLOAT32:
			*((float32 *) p_signal_inib->p_signal_buffer) = *((const float32 *) p_data);
			break;
#ifdef INT64_MAX
		case COM_FLOAT64:
			*((float64 *) p_signal_inib->p_signal_buffer) = *((const float64 *) p_data);
			break;
#endif /* INT64_MAX */
		default:
			/*
			 *  ܴؿΰCOM_BOOLEANCOM_SINT8COM_SINT16COM_SINT32COM_UINT8COM_UINT16
			 *  COM_UINT32COM_UINT8_NCOM_FLOAT32COM_FLOAT64ʳꤵ뤳ȤϤʤ
			 */
			COM_CHECK_PARAM(FALSE, COMServiceId_set_signal_for_send);
			break;
		}
	}

  error_exit:
	return;
}

/*
 *  TMSȽ
 */
LOCAL_INLINE boolean
check_tms(const IPDU_INIB *p_ipdu_inib)
{
	const SIGNAL_INIB	*p_signal_inib;
	const TX_SIGNAL_CB	*p_tx_signal_cb;
	Com_SignalIdType	i;
	boolean				filter = FALSE;
	boolean				tms = FALSE;

	for (i = 0U; i < p_ipdu_inib->tnum_signal; i++) {
		p_signal_inib = GET_SIGNAL_INIB((p_ipdu_inib->p_signalid_list)[i]);
		/* [COM676] ե륿ĥʥΤTMCȽꤹ */
		if (p_signal_inib->ComFilterAlgorithm != COM_INVALID_UINT8) {
			filter = TRUE;

			p_tx_signal_cb = (TX_SIGNAL_CB *) p_signal_inib->p_signal_cb;
			COM_CHECK_NULL_POINTER(p_tx_signal_cb != NULL_PTR, COMServiceId_check_tms);

			/* [COM678][COM679] TMC1ĤǤTRUEξϡTMSTRUEȤ */
			if (p_tx_signal_cb->tmc != FALSE) {
				tms = TRUE;
				break;
			}
		}
	}

	/* [COM677] ե륿ĥʥ뤬¸ߤʤϡTMSTRUEȤ */
	if (filter == FALSE) {
		tms = TRUE;
	}

  error_exit:
	return(tms);
}

/*
 *  ⡼ڤؤ
 */
LOCAL_INLINE void
switch_tx_mode(const IPDU_INIB *p_ipdu_inib, boolean tms)
{
	const TX_IPDU_INIB	*p_tx_ipdu_inib;
	TX_IPDU_CB	*p_tx_ipdu_cb;

	COM_CHECK_NULL_POINTER(p_ipdu_inib != NULL_PTR, COMServiceId_switch_tx_mode);

	p_tx_ipdu_inib = p_ipdu_inib->p_tx_ipdu_inib;
	p_tx_ipdu_cb = (TX_IPDU_CB *) p_ipdu_inib->p_ipdu_cb;

	COM_CHECK_NULL_POINTER(p_tx_ipdu_inib != NULL_PTR, COMServiceId_switch_tx_mode);
	COM_CHECK_NULL_POINTER(p_tx_ipdu_cb != NULL_PTR, COMServiceId_switch_tx_mode);

	/* [COM495][COM582] ⡼ɤڤؤäƤMDTˤϱƶʤ */
	/* [COM773] ⡼ɤڤؤäƤ⼺ȥ饤ˤϱƶʤ */ 

	if ((tms != FALSE) && (p_tx_ipdu_cb->p_cur_tx_mode_inib != p_tx_ipdu_inib->p_tx_mode_true_inib)) {
		/* [COM032] FALSE⡼ɢTRUE⡼ */
		set_tx_mode(p_ipdu_inib, TRUE);
	}
	else if ((tms == FALSE) && (p_tx_ipdu_cb->p_cur_tx_mode_inib != p_tx_ipdu_inib->p_tx_mode_false_inib)) {
		/* [COM032] TRUE⡼ɢFALSE⡼ */
		set_tx_mode(p_ipdu_inib, FALSE);
	}
	else {
		/* ⡼ɤڤؤʤ硤⤷ʤ */
	}
	
  error_exit:
	return;
}

/*
 *  ⡼
 */
LOCAL_INLINE void
set_tx_mode(const IPDU_INIB *p_ipdu_inib, boolean tms)
{
	const TX_IPDU_INIB	*p_tx_ipdu_inib;
	TX_IPDU_CB	*p_tx_ipdu_cb;

	COM_CHECK_NULL_POINTER(p_ipdu_inib != NULL_PTR, COMServiceId_set_tx_mode);

	p_tx_ipdu_inib = p_ipdu_inib->p_tx_ipdu_inib;
	p_tx_ipdu_cb = (TX_IPDU_CB *) p_ipdu_inib->p_ipdu_cb;

	COM_CHECK_NULL_POINTER(p_tx_ipdu_inib != NULL_PTR, COMServiceId_set_tx_mode);
	COM_CHECK_NULL_POINTER(p_tx_ipdu_cb != NULL_PTR, COMServiceId_set_tx_mode);

	if (tms != FALSE) {
		COM_CHECK_NULL_POINTER(p_tx_ipdu_inib->p_tx_mode_true_inib != NULL_PTR, COMServiceId_set_tx_mode);
		p_tx_ipdu_cb->p_cur_tx_mode_inib = p_tx_ipdu_inib->p_tx_mode_true_inib;
	}
	else {
		COM_CHECK_NULL_POINTER(p_tx_ipdu_inib->p_tx_mode_false_inib != NULL_PTR, COMServiceId_set_tx_mode);
		p_tx_ipdu_cb->p_cur_tx_mode_inib = p_tx_ipdu_inib->p_tx_mode_false_inib;
	}

	/* [COM244][COM495] ⡼ɴϢ󥿤ꥻå */
	p_tx_ipdu_cb->interval_mf_cnt = p_tx_ipdu_cb->p_cur_tx_mode_inib->ComTxModeRepetitionPeriod;
	p_tx_ipdu_cb->period_mf_cnt = p_tx_ipdu_cb->p_cur_tx_mode_inib->ComTxModeTimeOffset;
	p_tx_ipdu_cb->repeat_cnt = 0U;
	p_tx_ipdu_cb->queuing_cnt = 0U;
	p_tx_ipdu_cb->dm_mf_cnt = 0U;

	/* IPDUξ֤ꥻå */
	IPDU_CLEAR_NOTICED(p_ipdu_inib->p_state);
	IPDU_CLEAR_DIRECT_SEND(p_ipdu_inib->p_state);
	IPDU_CLEAR_FIRST_DIRECT_SEND(p_ipdu_inib->p_state);
	IPDU_CLEAR_DM(p_ipdu_inib->p_state);

  error_exit:
	return;
}


/*
 *  
 */
LOCAL_INLINE void
receive_ipdu(const IPDU_INIB *p_ipdu_inib)
{
	const SIGNAL_INIB		*p_signal_inib;
	const Com_ConfigType	*p_saved_config;
	void					*p_unpack_data;
#ifdef INT64_MAX
	uint64					temp_data;      /* 祵64ӥå */
#else
	uint32					temp_data;      /* 祵32ӥå */
#endif /* INT64_MAX */
	Com_CbkAck				cbk_ack;
	uint16					i;

	for (i = 0U; i < p_ipdu_inib->tnum_signal; i++) {
		p_signal_inib = GET_SIGNAL_INIB((p_ipdu_inib->p_signalid_list)[i]);

		/* [COM324] åץǡȥӥåȤƤ硤ե륿󥰡Ρѥåν»ܤ */
		if (check_updatebit(p_signal_inib) != FALSE) {

			if (p_signal_inib->ComSignalEndianness == COM_OPAQUE) {
				/* COM_UINT8_NϥХȥ饤󤵤ƤΤIPDUХåե򤽤Τޤ޻Ѥ */
				p_unpack_data = (void *) &((p_ipdu_inib->p_ipdu_buffer)[p_signal_inib->ComBitPositionLsb / 8U]);
			}
			else {
				/* COM_UINT8_NʳϰХåե˥ѥå */
				unpacking(p_signal_inib, &temp_data);
				p_unpack_data = (void *) &temp_data;
			}

			/*
			 *  [COM396] ʥФưʲνǽ
			 *           1) ̵ͽ
			 *           2) ե륿
			 *           3) 
			 */
			/* ̵ͽ([COM680][COM717]RTEΤϸ³ν򤷤ʤ) */
			if (check_invalid(p_signal_inib, p_unpack_data) != FALSE) {
				/* [COM273][COM695] ե륿󥰷̤falseξ硤ʥ˴ΥʥФԤʤ */
				if ((p_signal_inib->ComFilterAlgorithm == COM_INVALID_UINT8) || (filtering(p_signal_inib, p_unpack_data) != FALSE)) {
					/* ʥХåե˥ѥåǡǼ */
					set_rx_signal(p_signal_inib, p_unpack_data);

					/* [COM574] ˼ʥФComNotificationꤷؿƤ */
					if (p_signal_inib->ComNotification != NULL_PTR) {
						/* ¾ꥢǥХåΥݥ󥿤Ф */
						cbk_ack = p_signal_inib->ComNotification;
						/* ƽåѤ˸ߤΥե졼ݻ */
						p_saved_config = p_cur_com_config;

						/* λ */
						SchM_Exit_Com_Reentrant_0();
						cbk_ack();
						SchM_Enter_Com_Reentrant_0();

						/* ¾ꥢǥե졼ѲƤʤå */
						COM_CHECK_PARAM(p_saved_config == p_cur_com_config, COMServiceId_ipdu_receive);
					}
				}
			}
		}
	}

  error_exit:
	return;
}

/*
 *  ʥ륢ѥå
 *  [COM007] ǥѴĥ
 */
LOCAL_INLINE void
unpacking(const SIGNAL_INIB *p_signal_inib, void *p_data)
{
	const IPDU_INIB	*p_ipdu_inib;
	PduLengthType	byte_index;		/* LSBByte */
	uint8			pos_lsb;		/* LSBBit */
	uint8			bitsize;
	uint8			left_size;		/* ѥå륷ʥλĤꥵ */

	p_ipdu_inib = p_signal_inib->p_ipdu_inib;
	pos_lsb = (uint8) (p_signal_inib->ComBitPositionLsb % 8U);
	byte_index = p_signal_inib->ComBitPositionLsb / 8U;
	bitsize = p_signal_inib->ComBitSize;

	COM_CHECK_PARAM((p_signal_inib->ComSignalEndianness != COM_OPAQUE) &&
					((p_signal_inib->ComSignalEndianness == COM_LITTLE_ENDIAN) ||
					 (p_signal_inib->ComSignalEndianness == COM_BIG_ENDIAN)), COMServiceId_unpacking);

	/* ǼϰϤ1ByteǤ */
	if ((pos_lsb + bitsize) <= 8U) {
		/* ʥǡIPDUХåեΥǡǼ */
		*(uint64 *) p_data = (uint64) (((p_ipdu_inib->p_ipdu_buffer)[byte_index] >> pos_lsb) & (0xFFU >> (8U - bitsize)));
	}
	else {
		/* ʥǡIPDUХåեΥǡǼ */
#ifdef INT64_MAX
		*(uint64 *) p_data = (uint64) ((p_ipdu_inib->p_ipdu_buffer)[byte_index] >> pos_lsb);
#else
		*(uint32 *) p_data = (uint32) ((p_ipdu_inib->p_ipdu_buffer)[byte_index] >> pos_lsb);
#endif /* INT64_MAX */

		/* ʥλĤꥵ򻻽 */
		left_size = bitsize - (8U - pos_lsb);

		if (p_signal_inib->ComSignalEndianness == COM_LITTLE_ENDIAN) {
			byte_index++;
		}
		else {
			byte_index--;
		}

		/* ʥλĤꥵ1ByteʾǤ */
		while (left_size >= 8U) {
			/* ʥǡIPDUХåեΥǡ򡤤ޤǤ˳ǼӥåʬեȤƳǼ */
#ifdef INT64_MAX
			*(uint64 *) p_data += (((uint64) ((p_ipdu_inib->p_ipdu_buffer)[byte_index])) << (bitsize - left_size));
#else
			*(uint32 *) p_data += (((uint32) ((p_ipdu_inib->p_ipdu_buffer)[byte_index])) << (bitsize - left_size));
#endif /* INT64_MAX */
			left_size -= 8U;

			if (p_signal_inib->ComSignalEndianness == COM_LITTLE_ENDIAN) {
				byte_index++;
			}
			else {
				byte_index--;
			}
		}

		/* ʥλĤꥵ */
		if (left_size != 0U) {
			/* ʥǡIPDUХåեΥǡ򡤤ޤǤ˳ǼӥåʬեȤƳǼ */
#ifdef INT64_MAX
			*(uint64 *) p_data += ((uint64) (((p_ipdu_inib->p_ipdu_buffer)[byte_index]) & (0xFFU >> (8U - left_size))) << (bitsize - left_size));
#else
			*(uint32 *) p_data += ((uint32) (((p_ipdu_inib->p_ipdu_buffer)[byte_index]) & (0xFFU >> (8U - left_size))) << (bitsize - left_size));
#endif /* INT64_MAX */
		}
	}

	/* [COM008] ¦Ǥĥ */
	/* [COM352] ե륿󥰤θФԤĥȥǥѴԤ */
	switch (p_signal_inib->ComSignalType) {
	case COM_SINT8:
		if ((*((uint8 *) p_data) & ((uint8) (0x01U << (p_signal_inib->ComBitSize - 1U)))) != 0U) {
			*((uint8 *) p_data) |= (uint8) (0xFFU << p_signal_inib->ComBitSize);
		}
		break;
	case COM_SINT16:
		if ((*((uint16 *) p_data) & (((uint16) 0x0001) << (p_signal_inib->ComBitSize - 1U))) != 0U) {
			*((uint16 *) p_data) |= (0xFFFFU << p_signal_inib->ComBitSize);
		}
		break;
	case COM_SINT32:
		if ((*((uint32 *) p_data) & (((uint32) 0x00000001) << (p_signal_inib->ComBitSize - 1U))) != 0U) {
			*((uint32 *) p_data) |= (((uint32) 0xFFFFFFFF) << p_signal_inib->ComBitSize);
		}
		break;
	default:
		/*
		 *  ѥå󥰽COM_UINTѤƹԤäƤ뤿ᡤCOM_UINTĥ
		 *  [COM579] COM_FLOATĥϹԤʤ
		 */
		break;
	}

  error_exit:
	return;
}

/*
 * ̵ͤФ
 */
LOCAL_INLINE boolean
check_invalid(const SIGNAL_INIB *p_signal_inib, void *p_data)
{
	const Com_ConfigType	*p_saved_config;
	Com_CbkInv				cbk_inv;
	boolean					is_invalid;
	boolean					is_notified = TRUE;
	uint16					i;

	COM_CHECK_PARAM((p_signal_inib->ComDataInvalidAction == COM_NOTIFY) ||
					(p_signal_inib->ComDataInvalidAction == COM_REPLACE) ||
					(p_signal_inib->ComDataInvalidAction == COM_INVALID_UINT8), COMServiceId_invalid_action);

	if (p_signal_inib->ComSignalDataInvalidValue != NULL_PTR) {
		is_invalid = TRUE;
		switch (p_signal_inib->ComSignalType) {
		case COM_BOOLEAN:
			if (*((const boolean *) p_signal_inib->ComSignalDataInvalidValue) != *((boolean *) p_data)) {
				is_invalid = FALSE;
			}
			break;
		case COM_SINT8:
			if (*((const sint8 *) p_signal_inib->ComSignalDataInvalidValue) != *((sint8 *) p_data)) {
				is_invalid = FALSE;
			}
			break;
		case COM_SINT16:
			if (*((const sint16 *) p_signal_inib->ComSignalDataInvalidValue) != *((sint16 *) p_data)) {
				is_invalid = FALSE;
			}
			break;
		case COM_SINT32:
			if (*((const sint32 *) p_signal_inib->ComSignalDataInvalidValue) != *((sint32 *) p_data)) {
				is_invalid = FALSE;
			}
			break;
		case COM_UINT8:
			if (*((const uint8 *) p_signal_inib->ComSignalDataInvalidValue) != *((uint8 *) p_data)) {
				is_invalid = FALSE;
			}
			break;
		case COM_UINT16:
			if (*((const uint16 *) p_signal_inib->ComSignalDataInvalidValue) != *((uint16 *) p_data)) {
				is_invalid = FALSE;
			}
			break;
		case COM_UINT32:
			if (*((const uint32 *) p_signal_inib->ComSignalDataInvalidValue) != *((uint32 *) p_data)) {
				is_invalid = FALSE;
			}
			break;
		case COM_UINT8_N:
			for (i = 0U; i < p_signal_inib->ComSignalLength; i++) {
				if ((((const uint8 *) p_signal_inib->ComSignalDataInvalidValue)[i]) != (((uint8 *) p_data)[i])) {
					is_invalid = FALSE;
					break;
				}
			}
			break;
		case COM_FLOAT32:
			if (*((const float32 *) p_signal_inib->ComSignalDataInvalidValue) != *((float32 *) p_data)) {
				is_invalid = FALSE;
			}
			break;
#ifdef INT64_MAX
		case COM_FLOAT64:
			if (*((const float64 *) p_signal_inib->ComSignalDataInvalidValue) != *((float64 *) p_data)) {
				is_invalid = FALSE;
			}
			break;
#endif /* INT64_MAX */
		default:
			/*
			 *  ܴؿΰCOM_BOOLEANCOM_SINT8COM_SINT16COM_SINT32COM_UINT8COM_UINT16
			 *  COM_UINT32COM_UINT8_NCOM_FLOAT32COM_FLOAT64ʳꤵ뤳ȤϤʤ
			 */
			COM_CHECK_PARAM(FALSE, COMServiceId_invalid_action);
			break;
		}
	}
	else {
		/* NULL_PTRξ硤̵ͤǤϤʤΤȤư */
		is_invalid = FALSE;
	}

	if (is_invalid != FALSE) {
		if (p_signal_inib->ComDataInvalidAction == COM_NOTIFY) {
			/* [COM680][COM717] ComInvalidNotificationˤRTEΤե륿󥰡ʥΡʥХåեؤγǼϼ»ܤʤ */
			if (p_signal_inib->ComInvalidNotification != NULL_PTR) {
				/* ¾ꥢǥХåΥݥ󥿤Ф */
				cbk_inv = p_signal_inib->ComInvalidNotification;
				/* ƽåѤ˸ߤΥե졼ݻ */
				p_saved_config = p_cur_com_config;

				/* ̵ͼ */
				SchM_Exit_Com_Reentrant_0();
				cbk_inv();
				SchM_Enter_Com_Reentrant_0();

				/* ¾ꥢǥե졼ѲƤʤå */
				COM_CHECK_PARAM(p_saved_config == p_cur_com_config, COMServiceId_invalid_action);
			}
			is_notified = FALSE;
		}
		else if (p_signal_inib->ComDataInvalidAction == COM_REPLACE) {
			/* [COM681] COM_REPLACEξ硤ComSignalInitValueǥʥ򹹿 */
			switch (p_signal_inib->ComSignalType) {
			case COM_BOOLEAN:
				*((boolean *) p_data) = *((const boolean *) p_signal_inib->ComSignalInitValue);
				break;
			case COM_SINT8:
				*((sint8 *) p_data) = *((const sint8 *) p_signal_inib->ComSignalInitValue);
				break;
			case COM_SINT16:
				*((sint16 *) p_data) = *((const sint16 *) p_signal_inib->ComSignalInitValue);
				break;
			case COM_SINT32:
				*((sint32 *) p_data) = *((const sint32 *) p_signal_inib->ComSignalInitValue);
				break;
			case COM_UINT8:
				*((uint8 *) p_data) = *((const uint8 *) p_signal_inib->ComSignalInitValue);
				break;
			case COM_UINT16:
				*((uint16 *) p_data) = *((const uint16 *) p_signal_inib->ComSignalInitValue);
				break;
			case COM_UINT32:
				*((uint32 *) p_data) = *((const uint32 *) p_signal_inib->ComSignalInitValue);
				break;
			case COM_UINT8_N:
				for (i = 0U; i < p_signal_inib->ComSignalLength; i++) {
					((uint8 *) p_data)[i] = ((const uint8 *) p_signal_inib->ComSignalInitValue)[i];
				}
				break;
			case COM_FLOAT32:
				*((float32 *) p_data) = *((const float32 *) p_signal_inib->ComSignalInitValue);
				break;
#ifdef INT64_MAX
			case COM_FLOAT64:
				*((float64 *) p_data) = *((const float64 *) p_signal_inib->ComSignalInitValue);
				break;
#endif /* INT64_MAX */
			default:
				/*
				 *  ܴؿΰCOM_BOOLEANCOM_SINT8COM_SINT16COM_SINT32COM_UINT8COM_UINT16
				 *  COM_UINT32COM_UINT8_NCOM_FLOAT32COM_FLOAT64ʳꤵ뤳ȤϤʤ
				 */
				COM_CHECK_PARAM(FALSE, COMServiceId_invalid_action);
				break;
			}
		}
		else {
			/*
			 *  ̵ͤǤ(p_signal_inib->ComDataInvalidAction == COM_INVALID_UINT8)
			 *  [COM736] ComDataInvalidActionꤵƤʤСͭͤƤΤȤߤʤ
			 */
		}
	}

  error_exit:
	return(is_notified);
}

/*
 *  åץǡȥӥåȹå
 */
LOCAL_INLINE boolean
check_updatebit(const SIGNAL_INIB *p_signal_inib)
{
	const IPDU_INIB	*p_ipdu_inib;
	PduLengthType	index_update;       /* ComUpdateBitPosition°IPDUByte */
	uint8			pos_update;         /* ComUpdateBitPositionBit */
	boolean			updated;

	if (p_signal_inib->ComUpdateBitPosition != COM_INVALID_UINT16) {
		index_update = p_signal_inib->ComUpdateBitPosition / 8U;
		pos_update = (uint8) (p_signal_inib->ComUpdateBitPosition % 8U);
		p_ipdu_inib = p_signal_inib->p_ipdu_inib;

		/* [COM067] åץǡȥӥåȤͤꤵƤСʥϹ줿ΤȤ */
		if (((p_ipdu_inib->p_ipdu_buffer)[index_update] & ((uint8) (1U << pos_update))) != 0U) {
			updated = TRUE;
		}
		else {
			updated = FALSE;
		}
	}
	else {
		/* åץǡȥӥåȤʤϡ줿ΤȤ */
		updated = TRUE;
	}

	return(updated);
}

/*
 *  ʥХåեؤΥʥǡǼ()
 */
LOCAL_INLINE void
set_rx_signal(const SIGNAL_INIB *p_signal_inib, const void *p_data)
{
	uint16 i;

	/* ¦ΥʥХåեɬ¸ߤ */
	COM_CHECK_PARAM(p_signal_inib->p_signal_buffer != NULL_PTR, COMServiceId_set_signal_for_receive);

	switch (p_signal_inib->ComSignalType) {
	case COM_BOOLEAN:
		*((boolean *) p_signal_inib->p_signal_buffer) = *((const boolean *) p_data);
		break;
	case COM_SINT8:
		*((sint8 *) p_signal_inib->p_signal_buffer) = *((const sint8 *) p_data);
		break;
	case COM_SINT16:
		*((sint16 *) p_signal_inib->p_signal_buffer) = *((const sint16 *) p_data);
		break;
	case COM_SINT32:
		*((sint32 *) p_signal_inib->p_signal_buffer) = *((const sint32 *) p_data);
		break;
	case COM_UINT8:
		*((uint8 *) p_signal_inib->p_signal_buffer) = *((const uint8 *) p_data);
		break;
	case COM_UINT16:
		*((uint16 *) p_signal_inib->p_signal_buffer) = *((const uint16 *) p_data);
		break;
	case COM_UINT32:
		*((uint32 *) p_signal_inib->p_signal_buffer) = *((const uint32 *) p_data);
		break;
	case COM_UINT8_N:
		for (i = 0U; i < p_signal_inib->ComSignalLength; i++) {
			((uint8 *) p_signal_inib->p_signal_buffer)[i] = ((const uint8 *) p_data)[i];
		}
		break;
	case COM_FLOAT32:
		*((float32 *) p_signal_inib->p_signal_buffer) = *((const float32 *) p_data);
		break;
#ifdef INT64_MAX
		case COM_FLOAT64:
		*((float64 *) p_signal_inib->p_signal_buffer) = *((const float64 *) p_data);
		break;
#endif /* INT64_MAX */
		default:
		/*
		 *  ܴؿΰCOM_BOOLEANCOM_SINT8COM_SINT16COM_SINT32COM_UINT8COM_UINT16
		 *  COM_UINT32COM_UINT8_NCOM_FLOAT32COM_FLOAT64ʳꤵ뤳ȤϤʤ
		 */
		COM_CHECK_PARAM(FALSE, COMServiceId_set_signal_for_receive);
		break;
	}

  error_exit:
	return;
}

/*
 *  ʥХåեΥʥǡФ
 */
LOCAL_INLINE void
get_rx_signal(const SIGNAL_INIB *p_signal_inib, void *p_data)
{
	uint16 i;

	/* ʥǡμФϼΤߤǤΤɬХåե¸ߤ */
	COM_CHECK_PARAM(p_signal_inib->p_signal_buffer != NULL_PTR, COMServiceId_get_signal);

	switch (p_signal_inib->ComSignalType) {
	case COM_BOOLEAN:
		*((boolean *) p_data) = *((boolean *) p_signal_inib->p_signal_buffer);
		break;
	case COM_SINT8:
		*((sint8 *) p_data) = *((sint8 *) p_signal_inib->p_signal_buffer);
		break;
	case COM_SINT16:
		*((sint16 *) p_data) = *((sint16 *) p_signal_inib->p_signal_buffer);
		break;
	case COM_SINT32:
		*((sint32 *) p_data) = *((sint32 *) p_signal_inib->p_signal_buffer);
		break;
	case COM_UINT8:
		*((uint8 *) p_data) = *((uint8 *) p_signal_inib->p_signal_buffer);
		break;
	case COM_UINT16:
		*((uint16 *) p_data) = *((uint16 *) p_signal_inib->p_signal_buffer);
		break;
	case COM_UINT32:
		*((uint32 *) p_data) = *((uint32 *) p_signal_inib->p_signal_buffer);
		break;
	case COM_UINT8_N:
		for (i = 0U; i < p_signal_inib->ComSignalLength; i++) {
			((uint8 *) p_data)[i] = ((uint8 *) p_signal_inib->p_signal_buffer)[i];
		}
		break;
	case COM_FLOAT32:
		*((float32 *) p_data) = *((float32 *) p_signal_inib->p_signal_buffer);
		break;
#ifdef INT64_MAX
	case COM_FLOAT64:
		*((float64 *) p_data) = *((float64 *) p_signal_inib->p_signal_buffer);
		break;
#endif /* INT64_MAX */
	default:
		/*
		 *  ܴؿΰCOM_BOOLEANCOM_SINT8COM_SINT16COM_SINT32COM_UINT8COM_UINT16
		 *  COM_UINT32COM_UINT8_NCOM_FLOAT32COM_FLOAT64ʳꤵ뤳ȤϤʤ
		 */
		COM_CHECK_PARAM(FALSE, COMServiceId_get_signal);
		break;
	}

  error_exit:
	return;
}

/*
 *  DM
 */
LOCAL_INLINE void
start_rx_dm(const IPDU_INIB *p_ipdu_inib)
{
	Com_SignalIdType	i;
	const SIGNAL_INIB	*p_signal_inib;
	RX_SIGNAL_CB		*p_rx_signal_cb;
	boolean				is_dm = FALSE;

	for (i = 0U; i < p_ipdu_inib->tnum_signal; i++) {
		p_signal_inib = GET_SIGNAL_INIB((p_ipdu_inib->p_signalid_list)[i]);
		p_rx_signal_cb = (RX_SIGNAL_CB *) p_signal_inib->p_signal_cb;

		/* [COM333] ComTimeout0ޤϡάƤ硤ΥʥDMƻϤʤ */
		if (p_rx_signal_cb != NULL_PTR) {
			if (p_signal_inib->ComFirstTimeout == 0U) {
				/* [COM716] ComFirstTimeout0ޤϡάƤ硤ǽμԤޤǡΥʥDMƻϤʤ */
				p_rx_signal_cb->dm_state = COM_WAIT;
			}
			else {
				/* [COM224] ComFirstTimeoutꤹ */
				p_rx_signal_cb->dm_mf_cnt = p_signal_inib->ComFirstTimeout;
				p_rx_signal_cb->dm_state = COM_START;
			}

			is_dm = TRUE;
		}
	}

	if (is_dm == TRUE) {
		IPDU_SET_DM(p_ipdu_inib->p_state);
	}

	return;
}

/*
 *  DM
 */
LOCAL_INLINE void
stop_rx_dm(const IPDU_INIB *p_ipdu_inib)
{
	Com_SignalIdType	i;
	const SIGNAL_INIB	*p_signal_inib;
	RX_SIGNAL_CB		*p_rx_signal_cb;

	for (i = 0U; i < p_ipdu_inib->tnum_signal; i++) {
		p_signal_inib = GET_SIGNAL_INIB((p_ipdu_inib->p_signalid_list)[i]);
		p_rx_signal_cb = (RX_SIGNAL_CB *) p_signal_inib->p_signal_cb;

		if (p_rx_signal_cb != NULL_PTR) {
			/* ʥDMƻߤ */
			p_rx_signal_cb->dm_state = COM_STOP;
		}
	}

	/* DM */
	IPDU_CLEAR_DM(p_ipdu_inib->p_state);

	return;
}
/*
 *  ʥDMȽ
 */
LOCAL_INLINE void
check_rx_dm(const SIGNAL_INIB *p_signal_inib)
{
	const Com_ConfigType	*p_saved_config;
	RX_SIGNAL_CB			*p_rx_signal_cb;
	Com_CbkTOut				cbk_tout;

	p_rx_signal_cb = (RX_SIGNAL_CB *) p_signal_inib->p_signal_cb;

	if (p_rx_signal_cb != NULL_PTR) {
		if (p_rx_signal_cb->dm_state == COM_START) {
			/* dm_mf_cntɬ0礭ͤꤵƤ */
			p_rx_signal_cb->dm_mf_cnt--;

			/* ʥμDMͭDM󥿤Ƚꤹ */
			if (p_rx_signal_cb->dm_mf_cnt == 0U) {
				if (p_signal_inib->ComRxDataTimeoutAction == COM_REPLACE) {
					/* [COM470] ʥͤComSignalInitValue֤ */
					set_rx_signal(p_signal_inib, p_signal_inib->ComSignalInitValue);
				}
				/* [COM500] COM_NONEޤϾάƤϡ⤷ʤ */

				/* [COM744] ॢ */
				if (p_signal_inib->ComTimeoutNotification != NULL_PTR) {
					/* ¾ꥢǥХåΥݥ󥿤Ф */
					cbk_tout = p_signal_inib->ComTimeoutNotification;
					/* ƽåѤ˸ߤΥե졼ݻ */
					p_saved_config = p_cur_com_config;

					/* ॢ */
					SchM_Exit_Com_Reentrant_0();
					cbk_tout();
					SchM_Enter_Com_Reentrant_0();

					/* ¾ꥢǥե졼ѲƤʤå */
					COM_CHECK_PARAM(p_saved_config == p_cur_com_config, COMServiceId_TxConfirmation);
				}
				p_rx_signal_cb->dm_mf_cnt = p_signal_inib->ComTimeout;
			}
		}
	}

  error_exit:
	return;
}

/*
 *  ʥDMꥻå
 */
LOCAL_INLINE void
reset_rx_dm(const SIGNAL_INIB *p_signal_inib)
{
	RX_SIGNAL_CB *p_rx_signal_cb;

	p_rx_signal_cb = (RX_SIGNAL_CB *) p_signal_inib->p_signal_cb;

	if (p_rx_signal_cb != NULL_PTR) {
		if (p_rx_signal_cb->dm_state != COM_STOP) {
			/* ʥμǥåɥ饤󥿥ޤͭǤХꥻåȤ */
			p_rx_signal_cb->dm_mf_cnt = p_signal_inib->ComTimeout;

			if (p_rx_signal_cb->dm_state == COM_WAIT) {
				p_rx_signal_cb->dm_state = COM_START;
			}
		}
	}

	return;
}


/*
 *  ʲ̤ݡȵǽ
 */

/* <COM627><COM628><COM629><COM630> */
uint8
Com_SendDynSignal(Com_SignalIdType SignalId, const void *SignalDataPtr, uint16 Length)
{
	return(0U);
}
/* <COM690><COM711><COM712><COM724> */
uint8
Com_ReceiveDynSignal(Com_SignalIdType SignalId, void *SignalDataPtr, uint16 *Length)
{
	return(0U);
}
/* <COM200><COM635><COM636><COM637> */
uint8
Com_SendSignalGroup(Com_SignalGroupIdType SignalGroupId)
{
	return(0U);
}
/* <COM201><COM638><COM639><COM461> */
uint8
Com_ReceiveSignalGroup(Com_SignalGroupIdType SignalGroupId)
{
	return(0U);
}
/* <COM557><COM645> */
uint8
Com_InvalidateSignalGroup(Com_SignalGroupIdType SignalGroupId)
{
	return(0U);
}
/* <COM400><COM666><COM667><COM668> */
void
Com_MainFunctionRouteSignals(void)
{
}
/* <COM001><COM647><COM475><COM260><COM648><COM395><COM578><COM766> */
Std_ReturnType
Com_TriggerTransmit(PduIdType TxPduId, PduInfoType *PduInfoPtr)
{
	return(0U);
}
/* <COM650><COM651> */
void
Com_TpRxIndication(PduIdType PduId, NotifResultType Result)
{
}
/* <COM725> */
void
Com_TpTxConfirmation(PduIdType PduId, NotifResultType Result)
{
}
/* <COM691><COM654><COM655><COM656><COM657><COM721> */
BufReq_ReturnType
Com_StartOfReception(PduIdType ComRxPduId, PduLengthType TpSduLength, PduLengthType *RxBufferSizePtr)
{
	return(BUFREQ_OK);
}
/* <COM692><COM658><COM782> */
BufReq_ReturnType
Com_CopyRxData(PduIdType PduId, const PduInfoType *PduInfoPtr, PduLengthType *RxBufferSizePtr)
{
	return(BUFREQ_OK);
}
/* <COM693><COM663><COM783> */
BufReq_ReturnType
Com_CopyTxData(PduIdType PduId, PduInfoType *PduInfoPtr, RetryInfoType *RetryInfoPtr, PduLengthType *TxDataCntPtr)
{
	return(BUFREQ_OK);
}
